/* Output from p2c, the Pascal-to-C translator */
/* From input file "box_serv.p" */


/************************************************************/
/*                                                          */
/* DigiPoint SourceCode                                     */
/*                                                          */
/* Copyright (c) 1991-1997 Joachim Schurig, DL8HBS, Berlin  */
/*                                                          */
/* For license details see documentation                    */
/*                                                          */
/************************************************************/

/* 09.02.97 DL3NEU: added some features and updated Source  */

#include "defs.h"

#define BOX_SERV_G
#include "box_serv.h"


#ifndef MISC_OS_H
#include "misc_os.h"
#endif

#ifndef SORT_H
#include "sort.h"
#endif

#ifndef TOOLS_H
#include "tools.h"
#endif

#ifndef BOXGLOBL_H
#include "boxglobl.h"
#endif

#ifndef BOX_SEND_H
#include "box_send.h"
#endif

#ifndef YAPP_H
#include "yapp.h"
#endif

#ifndef BOXLOCAL_H
#include "boxlocal.h"
#endif

#ifndef BOX_SUB_H
#include "box_sub.h"
#endif

#ifndef BOX_INOU_H
#include "box_inou.h"
#endif

#ifndef BOX_FILE_H
#include "box_file.h"
#endif


Static unsigned short serv_sem, redserv_sem;


Static boolean valid_servername(Char *n_)
{
  Char n[256];
  
  if ((unsigned long)strlen(n_) >= 32 || ((1L << strlen(n_)) & 0x7e) == 0)
    return false;
  strcpy(n,n_);
  check_verteiler(n);
  if (callsign(n) || !defined_board(n))
    return true;
  return false;
}


Static void strip_call(Char *c1_, Char *c2, Char *c)
{
  Char c1[256];
  short k;

  strcpy(c1, c1_);
  if (c1[0] == '!') {
    *c = '!';
    strdelete((void *)c1, 1, 1);
  } else if (c1[0] == '#') {
    *c = '#';
    strdelete((void *)c1, 1, 1);
  } else
    *c = '\0';
  cut(c1, 6);
  k = strpos2(c1, "@", 1);
  if (k > 0)
    cut(c1, k - 1);
  del_lastblanks(c1);
  strcpy(c2, c1);
}


boolean in_servers(Char *board)
{
  Char s[256];

  if (!strcmp(board, "LSTSRV"))
    return true;
  sprintf(s, "%s%s%cSRV", serverdir, board, extsep);
  return (exist(s));
}


Static short in_abonnees(Char *sender, Char *board)
{
  short ifl;
  boolean ok, sflag;
  Char c;
  Char hs[256], c1[256];
  Char STR1[256];

  ok = false;
  sflag = false;

  if (in_servers(board)) {
    sprintf(STR1, "%s%s%cSRV", serverdir, board, extsep);
    ifl = sfopen(STR1, FO_READ);
    while (file_to_string(ifl, hs) && !ok) {
      strip_call(hs, c1, &c);
      sflag = (c == '!');
      ok = ((strcmp(c1, sender) == 0) && (c != '#'));
    }
    sfclose(&ifl);

    /* DL5HBF: An Console_call darf JEDER schreiben */
    if (!ok && !strcmp(board, Console_call))
      ok = true;
  
    /* DL5HBF: Bloss der Absender darf nicht der Servername sein, */
    /*         sonst gibt's 'ne huebsche Schleife :-))            */
    if (!strcmp(board, sender))
      ok = false;
  }

  if (!ok)
    return 0;
  if (sflag)
    return 2;
  return 1;
}

Static boolean is_public(Char *board)
{
  short ifl;
  boolean ok;
  Char c;
  Char hs[256], c1[256];
  Char STR1[256];

  ok = false;

  if (!strcmp(board, "LSTSRV")) return true;
  if (in_servers(board)) {
    sprintf(STR1, "%s%s%cSRV", serverdir, board, extsep);
    ifl = sfopen(STR1, FO_READ);
    while (file_to_string(ifl, hs) && !ok) {
      strip_call(hs, c1, &c);
      ok = ((strcmp(c1, "PUBLIC") == 0) && (c == '#'));
    }
    sfclose(&ifl);
  }

  return ok;
}

Static boolean u_subscribe(Char *sender_, Char *board_, Char *betreff_);

#define blocksize       16384

boolean do_server(Char *sender_, Char *board_, Char *betreff_, Char *tname_,
		  long offset)
{
  boolean Result;
  Char sender[256];
  Char board[256], betreff[256], tname[256];

  short ifl, ifs, ifc, k, x, y, unr, kanal, k2;
  uchar *tb;
  long tbs, rp, lrp, lrp2;
  boolean ok;
  long cntmsg, cntabonnees;
  Char c;
  Char svname[256];
  Char sublist[256];
  Char svcnt[256];
  Char svsysop[256];
  Char hs[256], name[256];
  Char tobbs[256];
  Char w[256], nname[256];
  Char betreff1[256];
  Char STR7[256];

  strcpy(sender, sender_);
  strcpy(board, board_);
  strcpy(betreff, betreff_);
  strcpy(tname, tname_);
  serv_sem++;
  Result = false;
  if (exist(tname) && callsign(sender)) {
    if (!u_subscribe(sender, board, betreff)) {
      if (in_abonnees(sender, board) > 0) {
	unr = melde_user_an(sender, 0, 0, UM_SYSREQ, false);
	if (boxrange(unr)) {
	  strcpy(betreff1, betreff);
	  kanal = sfopen(tname, FO_READ);
	  if (kanal >= minhandle) {
	    sfseek(offset, kanal, SFSEEKSET);
	    tb = Malloc(blocksize);
	    if (tb != NULL) {
	      tbs = sfread(kanal, blocksize, tb);
	      sfclose(&kanal);
	      rp = 0;
	      lrp = 0;
	      lrp2 = 0;
	      ok = true;
	      while (rp + 10 < tbs && ok) {
		get_line(tb, &rp, tbs, hs);
		if (strpos2(hs, "R:", 1) != 1)
		  ok = false;
		else {
		  lrp2 = lrp;
		  lrp = rp;
		}
	      }
	      offset += lrp2;
	    } else
	      sfclose(&kanal);
	    sprintf(w, "%ld", serv_sem);
	    sprintf(nname, "%s249WS%s%cSRV", tempdir, w, extsep);
	    filecut_nodel(tname, nname, offset, 0);

	    sprintf(sublist, "%s247WW%s%cSUB", tempdir, w, extsep);
	    sprintf(svname, "%s%s%cSRV", serverdir, board, extsep);
	    sprintf(svcnt, "%s%s%cCNT", serverdir, board, extsep);
	    *svsysop = '\0';
	    if (exist(svcnt)) {
	      ifc = sfopen(svcnt, FO_READ);
	      file_to_string(ifc, w);
	      sfclose(&ifc);
	      cntmsg = str2lint(w);
	    } else
	      cntmsg = 0;
	    cntmsg++;
	    ifc = sfcreate(svcnt, FC_FILE);
	    sprintf(w, "%ld", cntmsg);
	    string_to_file(&ifc, w, true);
	    sfclose(&ifc);

	    sprintf(STR7, "(%s ", board);
	    x = strpos2(betreff1, STR7, 1);
	    if (x > 0) {
	      y = strpos2(betreff1, ") ", 1);
	      if (y > x)
		strdelete((void *)betreff1, x, y - x + 2);
	    }
	    sprintf(betreff1, "(%s %s) %s", board, w, strcpy(STR7, betreff1));

	    ifl = sfopen(svname, FO_READ);
	    ifs = sfcreate(sublist, FC_FILE);
	    *hs = '\0';
	    cntabonnees = 0;
	    while (file_to_string(ifl, w)) {
	      strip_call(w, name, &c);
	      if (c != '#') {
                if (c == '!') {
                  if (*svsysop == '\0')
		    strcpy(svsysop, name);
		  else if (strlen(svsysop) < 70)
		    sprintf(svsysop + strlen(svsysop), " %s", name);
	        }
	        if (*hs == '\0')
                  strcpy(hs, name);
	        else if (strlen(hs) < 70)
		  sprintf(hs + strlen(hs), " %s", name);
	        else {
		  string_to_file(&ifs, hs, true);
		  strcpy(hs, name);
	        }
                cntabonnees++;
              }
	    }
	    if (*hs != '\0')
	      string_to_file(&ifs, hs, true);
	    sfclose(&ifl);
	    sfclose(&ifs);

	    ifl = sfopen(svname, FO_READ);
	    if (ifl >= minhandle) {
	      while (file_to_string(ifl, hs)) {
		dp_watchdog(2, 4711);   /* Watchdog resetten         */

		if (*hs == '\0')
		  continue;
		strip_call(hs, name, &c);
                if (c == '#')
                  continue;
                if (useq(name, board))
                  continue;
		k = strpos2(hs, "@", 1);
		if (k > 0)
		  strdelete((void *)hs, 1, k);
		else
		  *hs = '\0';
		del_leadblanks(hs);
		strcpy(tobbs, hs);
		if (*tobbs != '\0')
		  sprintf(tobbs, " @ %s", strcpy(STR7, tobbs));

		sprintf(w, " < %s %s", sender, betreff1);
		sprintf(hs, "%s%s %s", name, tobbs, w);

		user[unr]->input2[0] = '\0';
		send_check(unr, hs, false, '\0');
		if (user[unr]->sendchan < minhandle) {
		  boxprotokoll("file error (server)");
		  continue;
		}


		Result = true;
		kanal = sfopen(nname, FO_READ);
		if (kanal >= minhandle) {
		  sprintf(STR7,
			  "Mail processed by dpbox mailing list server %s@%s",
			  board, ownhiername);
		  send_text3(unr, false, STR7, true);
		  send_text3(unr, false, "  ", true);
		  if (cntabonnees <= maxsubscriberdisp) {
                    send_text3(unr, false, "Subscriber list:", true);
		    k2 = sfopen(sublist, FO_READ);
		    if (k2 >= minhandle)
		      send_file1(unr, &k2, false, 1);
		  } else {
                    sprintf(STR7, "There are %d users on the list",
                            cntabonnees);
		    send_text3(unr, false, STR7, true);
                  }
		  send_text3(unr, false, "  ", true);
		  sprintf(STR7, "For server redistribution reply to %s@%s",
			  board, ownhiername);
		  send_text3(unr, false, STR7, true);
		  if (*svsysop != '\0') {
		    sprintf(STR7, "Server is maintained by %s", svsysop);
		    send_text3(unr, false, STR7, true);
		  }
		  send_text3(unr, false, "  ", true);
		  send_text3(unr, false,
		    "-----------------------------------------------------------------------------",
		    true);
		  send_file1(unr, &kanal, false, 1);
		} else
		  send_text3(unr, false, "*** read error", true);
		send_text3(unr, false, "***END", true);
	      }

	      sfclose(&ifl);
	    }
	    sfdelfile(nname);
	    sfdelfile(sublist);
	  }
	}
	melde_user_ab(unr, false);
      }

    } else
      Result = true;
  }
  serv_sem--;
  return Result;
}

#undef blocksize


Static void list_abonnees(short unr, Char *sname, Char *call_)
{
  Char call[256];
  short ifl;
  Char svname[256];
  Char hs[256], w[256], w0[256];
  Char STR7[256];

  strcpy(call, call_);
  serv_sem++;
  if (in_servers(sname)) {
    sprintf(svname, "%s%s%cSRV", serverdir, sname, extsep);
    w_btext(unr, 115);
    sprintf(STR7, " %s:", sname);
    wlnuser(unr, STR7);
    ifl = sfopen(svname, FO_READ);
    *w0 = '\0';
    if (*call != '\0' && call[strlen(call) - 1] != '*')
      strcat(call, "*");
    while (file_to_string(ifl, hs)) {
      if (hs[0] == '#')
        continue;
      upper(hs);
      if (*call == '\0') {
        wlnuser(unr, hs);
        continue;
      }
      strcpy(w, hs);
      if (w[0] == '!')
        strdelete((void *)w, 1, 1);
      if (wildcardcompare(SHORT_MAX, call, w, w0))
        wlnuser(unr, hs);
    }
    sfclose(&ifl);
  } else
    wln_btext(unr, 45);
  serv_sem--;
}


Static boolean add_abonnee(short unr, Char *sname, Char *call, boolean public)
{
  boolean Result;
  short ifl, ofl;
  Char c;
  Char svname[256];
  Char ovname[256];
  Char hs[256], c1[256], c2[256];
  Char STR1[256], STR7[256];

  serv_sem++;
  Result = false;
  sprintf(svname, "%s%s%cSRV", serverdir, sname, extsep);
  strip_call(call, c1, &c);
  if (strcmp(sname, "LSTSRV") && (callsign(c1) || public)) {
    if (!in_servers(sname)) {
      w_btext(unr, 116);
      sprintf(STR1, " %s", sname);
      wlnuser(unr, STR1);
      w_btext(unr, 117);
      sprintf(STR7, " %s ", c1);
      wlnuser(unr, STR7);
      w_btext(unr, 118);
      chwuser(unr, 32);
      wlnuser(unr, sname);
      ofl = sfcreate(svname, FC_FILE);
      if (ofl >= minhandle) {
	string_to_file(&ofl, call, true);
	sfclose(&ofl);
        Result = true;
      } else
	wln_btext(unr, 119);
    } else {
      sprintf(ovname, "%s%s%cSRX", serverdir, sname, extsep);
      w_btext(unr, 117);
      sprintf(STR1, " %s ", c1);
      wlnuser(unr, STR1);
      w_btext(unr, 118);
      chwuser(unr, 32);
      wlnuser(unr, sname);
      ifl = sfopen(svname, FO_READ);
      ofl = sfcreate(ovname, FC_FILE);
      while (file_to_string(ifl, hs)) {
	strip_call(hs, c2, &c);
	if (strcmp(c1, c2))
	  string_to_file(&ofl, hs, true);
      }
      string_to_file(&ofl, call, true);
      sfclose(&ifl);
      sfclose(&ofl);
      sfdelfile(svname);
      sfrename(ovname, svname);
      sort_file(svname);
      Result = true;
    }
  }
  serv_sem--;
  return Result;
}


Static boolean sub_abonnee(short unr, Char *sname, Char *call, boolean public)
{
  boolean Result;
  short ifl, ofl, ct;
  Char c;
  Char svname[256];
  Char ovname[256];
  Char hs[256];
  Char c1[256], c2[256];
  Char STR7[256];

  serv_sem++;
  Result = false;
  if (in_servers(sname)) {
    sprintf(svname, "%s%s%cSRV", serverdir, sname, extsep);
    sprintf(ovname, "%s%s%cSRX", serverdir, sname, extsep);
    strip_call(call, c1, &c);
    if (callsign(c1) || public) {
      w_btext(unr, 120);
      sprintf(STR7, " %s ", c1);
      wlnuser(unr, STR7);
      w_btext(unr, 118);
      chwuser(unr, 32);
      wlnuser(unr, sname);
      ct = 0;
      ifl = sfopen(svname, FO_READ);
      ofl = sfcreate(ovname, FC_FILE);
      while (file_to_string(ifl, hs)) {
	strip_call(hs, c2, &c);
	if (strcmp(c1, c2)) {
	  string_to_file(&ofl, hs, true);
	  ct++;
	} else
          wlnuser(unr, "OK");
      }
      sfclose(&ifl);
      sfclose(&ofl);
      sfdelfile(svname);
      if (ct == 0) {
	sfdelfile(ovname);
	new_ext(ovname, "CNT");
	sfdelfile(ovname);
        w_btext(unr, 121);
        chwuser(unr, 32);
        wlnuser(unr, sname);
      }
      sfrename(ovname, svname);
      Result = true;
    }
  } else {
    wln_btext(unr, 45);
  }
  serv_sem--;
  return Result;
}

/* Bestaetigungsmail generieren */
Static void gen_svackmail(Char *sender_,Char *server_, short Subscribe)
{

  short result;
  short k, ifl, l;
  Char hs[256], infoname[256];
  Char STR7[256];
  Char sender[256], server[256];
  Char svname[256], ivname[256];
  Char svsysop[256];
  Char w[256], w1[256], c, c1[256];
  Char infotxt[256]; 
  unsigned short date, time;
  DTA dirinfo;

  strcpy(sender, sender_);
  strcpy(server, server_);
  upper(sender);
  upper(server);
  
  sprintf(hs, "%simport%c001", newmaildir, extsep);
  validate(hs);
  k = sfcreate(hs, FC_FILE);
  if (k >= minhandle) {
    string_to_file(&k, Console_call, true); /* frombox */
    string_to_file(&k, Console_call, true); /* absender */
    string_to_file(&k, sender, true);       /* an */
    *hs = '\0';
    rspacing(hs, 60);
    string_to_file(&k, hs, true);    /* mbx */
    string_to_file(&k, hs, true);    /* lt */
    string_to_file(&k, hs, true);    /* BID */

    if (Subscribe == 0)
      sprintf(hs, "LSTSRV: Error occured at your request to %s", server);
    else if (Subscribe == 1)
      sprintf(hs, "LSTSRV: Subscribed to list server %s", server);
    else if (Subscribe == 2)
      sprintf(hs, "LSTSRV: Unsubscribed from list server %s", server);
    else if (Subscribe == 3)
      sprintf(hs, "LSTSRV: Subscriber list of server %s", server);
    else if (Subscribe == 4)
      sprintf(hs, "LSTSRV: Public mailing list servers at %s", Console_call);

    string_to_file(&k, hs, true);   /* subject */
    sprintf(hs, "From: %s @ %s", Console_call, ownhiername);
    string_to_file(&k, hs, true);
    sprintf(hs, "To:   %s", sender);
    string_to_file(&k, hs, true);
    string_to_file(&k, " ", true);

    strcpy(STR7, "Mail generated by dpbox mailing list server:");
    string_to_file(&k, STR7, true);
    string_to_file(&k, " ", true);

    if (Subscribe == 0) {
      string_to_file(&k, "Executing your command an error occured", true);
      string_to_file(&k, "Try again or write a mail to the sysop", true);
    } else if (Subscribe == 1) {
      sprintf(STR7, "You are now subscribed to list server %s.", server);    
      string_to_file(&k, STR7, true);
      sprintf(STR7, 
              "Send a mail to LSTSRV@%s with subject  UNSUBSCRIBE %s ",
              ownhiername, server);
      string_to_file(&k, STR7, true);
      string_to_file(&k, "if you want to unsubscribe from this server.", true);
/* wenn vorhanden, Infomail des Sysops ausgeben... */
      sprintf(infoname, "%s%s%cINF", serverdir, server, extsep); 
      if (exist(infoname)) {
        string_to_file(&k, " ", true);
        string_to_file(&k, "Server info: ", true);
        strcpy(STR7, 
    "----------------------------------------------------------------------");
        string_to_file(&k, STR7, true);
        app_file(infoname, k, false); 
        string_to_file(&k, STR7, true);
      }


    } else if (Subscribe == 2) {
      sprintf(STR7, "You are unsubscribed from list server %s.",
               server); 
      string_to_file(&k, STR7, true);
    

    } else if (Subscribe == 3) {
      sprintf(svname, "%s%s%cSRV", serverdir, server, extsep);
      sprintf(STR7, "Subscriber list of server %s:", server);
      string_to_file(&k, STR7, true);
      ifl = sfopen(svname, FO_READ);
      *hs = '\0';
      *svsysop = '\0';
      while (file_to_string(ifl, w)) {
        strip_call(w, c1, &c);
	if (c != '#') {
          if (c == '!') {
            if (*svsysop == '\0')
              strcpy(svsysop, c1);
            else if (strlen(svsysop) < 70)
              sprintf(svsysop + strlen(svsysop), " %s", c1);
          }
	  if (*hs == '\0')
            strcpy(hs, c1);
	  else if (strlen(hs) < 70)
            sprintf(hs + strlen(hs), " %s", c1);
          else {
            string_to_file(&k, hs, true);
            strcpy(hs, c1);
	  }
        }
      }
      if (*hs != '\0')
      string_to_file(&k, hs, true);
      if (*svsysop != '\0') {
        string_to_file(&k, " ", true);
        sprintf(STR7, "Server is maintained by %s", svsysop);
        string_to_file(&k, STR7, true);
      }
      sfclose(&ifl);

    } else if (Subscribe == 4) {
      string_to_file(&k, "Installed public listservers:", true);
      string_to_file(&k, " ", true);
      string_to_file(&k, "Name   Count LastAccess        Infotext", true);
      string_to_file(&k,
      "-----------------------------------------------------------", true);

      sprintf(svname, "%s%c%cSRV", serverdir, allquant, extsep);
      result = sffirst(svname, 0, &dirinfo);   /* alle normalen Files suchen */
      while (result == 0) {
        strcpy(w, dirinfo.d_fname);
        del_ext(w);
        if (!is_public(w)) {
          result = sfnext(&dirinfo);
          continue;
        }
        sprintf(ivname, "%s%s%cSRV", serverdir, w, extsep);
        sprintf(STR7, "%s%s%cCNT", serverdir, w, extsep);
        l = sfopen(STR7, FO_READ);
        rspacing(w, 8);
        string_to_file(&k, w, false);
        strcpy(w, "0");
        strcpy(w1, "-");
        if (l >= minhandle) {
          file_to_string(l, w);
          sfclose(&l);
          sfgetdatime(STR7, &date, &time);
          dosdt2string(date, time, w1);
        }
        lspacing(w, 4);
        string_to_file(&k, w, false);
        string_to_file(&k, " ", false);
        string_to_file(&k, w1, false);
        string_to_file(&k, " ", false);
        ifl = sfopen(ivname, FO_READ);
        while (file_to_string(ifl, hs)) {
          strip_call(hs, c1, &c);
          if (!strcmp("PUBLIC", c1) && (c == '#')) {
            strdelete((void *)hs, 1, 8);
            strcpy(infotxt, hs);
          }
        }
        sfclose(&ifl);
        string_to_file(&k, infotxt, true);
        result = sfnext(&dirinfo);
      }
      string_to_file(&k, 
        "-----------------------------------------------------------", true);
    }
    string_to_file(&k, " ", true);
    sprintf(STR7, "73 de %s", Console_call);
    string_to_file(&k, STR7, true);
  }
  sfclose(&k);
}

/* DL3NEU: Subscribe bzw. Unsubscribe per Mail */
Static boolean u_subscribe(Char *sender_, Char *board_, Char *betreff_)
{
  boolean ok;
  Char betreff1[256];
  Char sender1[256];
  Char board1[256];
  Char STR1[256];
  short what;


  strcpy(betreff1, betreff_);
  upper(betreff1);
  get_word(betreff1, STR1);
  strcpy(board1, board_);
  upper(board1);

  if (!strcmp(STR1, "SUBSCRIBE"))
    what = 1;
  else if (!strcmp(STR1, "UNSUBSCRIBE"))
    what = 2;
  else if (!strcmp(STR1, "LISTABONNEES"))
    what = 3;
  else if (!strcmp(STR1, "SUBSCRIBERS"))
    what = 3;
  else if (!strcmp(STR1, "LISTSERV"))
    what = 4;
  else if (!strcmp(STR1, "LISTSERVER"))
    what = 4;
  else if (!strcmp(STR1, "LISTSERVERS"))
    what = 4;
  else if (!strcmp(board1, "LSTSRV")) {
    sprintf(STR1, "invalid command: %s - from: %s", betreff_, sender_);
    append_profile(-7, STR1);
    return true;
  } else
    return false;

  strcpy(sender1, sender_);
  
  if (!strcmp(board1, "LSTSRV") || !strcmp(board1, Console_call))
    get_word(betreff1, board1);

  if (!is_public(board1) && !(what == 3 || what == 4))
    return true;

  switch (what) {
  
  case 1:
    if (in_abonnees(sender1, board1) <= 0) {
      ok = (add_abonnee(-7, board1, sender1, false)); 
      if (ok) {
        gen_svackmail(sender1, board1, 1);
        sprintf(STR1, "%s subscribed at server %s", sender1, board1);
        append_profile(-7, STR1);
      } else {
        gen_svackmail(sender1, board1, 0);
        sprintf(STR1, "Subscribe of %s at server %s failed", sender1, board1);
        append_profile(-7, STR1);
      }
    }
    return true;
    break;

  case 2:
    if (in_abonnees(sender1, board1) > 0) {
      ok = sub_abonnee(-7, board1, sender1, false);
      if (ok) {
        gen_svackmail(sender1, board1, 2);
        sprintf(STR1, "%s unsubscribed from server %s", sender1, board1);
        append_profile(-7, STR1);
      } else {
        gen_svackmail(sender1, board1, 0);
        sprintf(STR1, "Unsubscribe of %s from server %s failed", sender1,
           	board1);
        append_profile(-7, STR1);
      }
    }
    return true;
    break;
    
  case 3:
    /* list abonnees of a pubserv */
    if (in_abonnees(sender1, board1) > 0)
      gen_svackmail(sender1, board1, 3);
    return true;
    break;
        
  case 4:
    /* List all public listservers */
    gen_svackmail(sender1, board1, 4);
    return true;
    break;

  default:
    return false;
    
  }

}


Static void list_servers(short unr, boolean All, boolean Subscribed)
{
  DTA dirinfo;
  short result, k, ifl;
  Char w[256], w1[256];
  Char STR1[256];
  Char svname[256], ivname[256];
  Char c;
  Char c1[256], hs[256], infotxt[256];
  unsigned short date, time;

  if (All && !Subscribed)
    wln_btext(unr, 122);
  else if (!All && !Subscribed)
    wlnuser(unr, "Installed public listservers:");
  else if (Subscribed)
    wlnuser(unr, "Listservers you are subscribed to:");

  wlnuser0(unr);
  if (!All) {
    wlnuser(unr, "Name   Count LastAccess        Infotext");
    wlnuser(unr, "-----------------------------------------------------------");
  } else {
    wlnuser(unr, "Name   Count LastAccess");
    wlnuser(unr, "------------------------------");
  }

  sprintf(svname, "%s%c%cSRV", serverdir, allquant, extsep);
  result = sffirst(svname, 0, &dirinfo);   /* alle normalen Files suchen */
  while (result == 0) {
    strcpy(w, dirinfo.d_fname);
    del_ext(w);
    if (!All && !is_public(w)) {
      result = sfnext(&dirinfo);
      continue;
    } else if ((Subscribed && !strcmp(w, Console_call))
               || (Subscribed && !in_abonnees(user[unr]->call, w))) {
      result = sfnext(&dirinfo);
      continue;
    }
    sprintf(ivname, "%s%s%cSRV", serverdir, w, extsep);
    sprintf(STR1, "%s%s%cCNT", serverdir, w, extsep);
    k = sfopen(STR1, FO_READ);
    rspacing(w, 8);
    wuser(unr, w);
    strcpy(w, "0");
    strcpy(w1, "-");
    if (k >= minhandle) {
      file_to_string(k, w);
      sfclose(&k);
      sfgetdatime(STR1, &date, &time);
      dosdt2string(date, time, w1);
    }
    lspacing(w, 4);
    wuser(unr, w);
    chwuser(unr, 32);
    if (!All) {
      wuser(unr, w1);
      chwuser(unr, 32);
      ifl = sfopen(ivname, FO_READ);
      while (file_to_string(ifl, hs)) {
        strip_call(hs, c1, &c);
        if (!strcmp("PUBLIC", c1) && (c == '#')) {
          strdelete((void *)hs, 1, 8);
          strcpy(infotxt, hs);
        }
      }
      sfclose(&ifl);
      wlnuser(unr, infotxt);
    } else
      wlnuser(unr, w1); 
    result = sfnext(&dirinfo);
  }
  if (!All)
    wlnuser(unr, "-----------------------------------------------------------");
  else
    wlnuser(unr, "------------------------------");
}

Static boolean lock_abonnee(short unr, Char *sname, Char *call)
{
  boolean Result;
  Char call1[256];
  Char STR1[256];
  Result = false;

  if ((in_abonnees(call, sname)) > 0)
    sub_abonnee(-7, sname, call, false);
  sprintf(call1, "#%s", call);
  if (add_abonnee(-7, sname, call1, false)) {
    sprintf(STR1, 
            "OK, User %s now may not subscribe himself any more to server %s",
            call, sname);
    wlnuser(unr, STR1);
    Result = true;
  }
  return Result;
}


/* set public flag and infotext of a listserver */
Static boolean toggle_pubserv(short unr, Char *sname, uchar mode,
                	      Char *eingabe)
{
  boolean ok, Result;
  Char svname[256], ausgabe[256];
  Char hs[256], c1[256];
  uchar c;
  short ifl;
  Result = false;

  sprintf(svname, "%s%s%cSRV", serverdir, sname, extsep);

  ok = false;
  ifl = sfopen(svname, FO_READ);
  while (file_to_string(ifl, hs)) {
    strip_call(hs, c1, &c);
    if (!strcmp("PUBLIC", c1) && (c == '#'))
      ok = true;
  }
  sfclose(&ifl);

  switch (mode) {

  case 1:
    if (!ok) {
      if (add_abonnee(-7, sname, "#PUBLIC@", true))
        Result = true;
    }
    break;

  case 2:      
    if (ok) {
      if (sub_abonnee(-7, sname, "#PUBLIC", true))
        Result = true;
    }
    break;
    
  case 3:
    if (ok) {
      ifl = sfopen(svname, FO_READ);
      while (file_to_string(ifl, hs)) {
        strip_call(hs, c1, &c);
        if (!strcmp("PUBLIC", c1) && (c == '#')) {
          strdelete((void *)hs, 1, 8);
          strcpy(eingabe, hs);
          Result = true;
          
        }
      }
      sfclose(&ifl);
    }
    break;

  case 4:
    if (ok) {
      if (sub_abonnee(-7, sname, "#PUBLIC", true)) {
        sprintf(ausgabe, "#PUBLIC@%s", eingabe);
        if (add_abonnee(-7, sname, ausgabe, true))
          Result = true;
      }
    }
    break;
  }
  return Result;
}


boolean config_server(short unr, Char *eingabe_)
{
  boolean Result;
  Char eingabe[256];
  Char sname[256];
  Char w[256], w1[256];
  Char STR1[256];

  strcpy(eingabe, eingabe_);
  Result = false;
  if (!boxrange(unr))
    return Result;

  switch (eingabe[0]) {
  
  case '\0':
    list_servers(unr, user[unr]->supervisor, false);
    Result = true;
    break;

  case '?':
    list_servers(unr, true, true);
    Result = true;
    break;

  case '!':
    if (!user[unr]->supervisor) {
      list_servers(unr, false, false);
      Result = true;
    } else {
     get_word(eingabe, w);
     get_word(eingabe, sname);
     if (*sname == '\0' && w[1] != '\0')
       break;
     upper(sname);

     switch (w[1]) {

     case '+':
       if (toggle_pubserv(unr, sname, 1, '\0')) {
         sprintf(STR1, "OK, server %s is now public", sname);
         wlnuser(unr, STR1); 
       } else {
         sprintf(STR1, "Server %s is already public", sname);
         wlnuser(unr, STR1);
       }
       Result = true;
       break;

     case '-':
       if (toggle_pubserv(unr, sname, 2, '\0')) {
         sprintf (STR1, "OK, server %s is now private", sname);
         wlnuser(unr, STR1);      
       } else {
         sprintf(STR1, "Server %s is already private", sname);
         wlnuser(unr, STR1);
       }
       Result = true;
       break;
   
    case '=':
      if (eingabe[0] == '\0') {
        if (toggle_pubserv(unr, sname, 3, eingabe)) {
          sprintf(STR1, "Infotext of server %s:", sname);
          wlnuser(unr, STR1);
          wlnuser(unr, eingabe);
        } else
          wlnuser(unr, "Server is not public or infotext unset");
      } else {
        if (toggle_pubserv(unr, sname, 4, eingabe)) {
          sprintf(STR1, "OK, infotext of server %s set to", sname);
          wlnuser(unr, STR1);
          wlnuser(unr, eingabe);
        } else
          wlnuser(unr, "Server is not public");
      }
      Result = true;
      break;
   
    default:
      /* list only public servers */
      list_servers(unr, false, false);
      Result = true;
      break;
    }
    break;
  }

  default:
    get_word(eingabe, sname);
    upper(sname);
    if (!valid_servername(sname))
      return Result;
    if (!(user[unr]->supervisor || in_abonnees(user[unr]->call, sname) == 2
          || is_public(sname)))
      return Result;
    get_word(eingabe, w);
    get_word(eingabe, w1);
    upper(w1);
    if (strlen(w) != 1)
      return Result;
    Result = true;

    switch (w[0]) {

    case '+':
      add_abonnee(unr, sname, w1, false);
      break;

    case '-':
      sub_abonnee(unr, sname, w1, false);
      break;

    case '=':
      list_abonnees(unr, sname, w1);
      break;

    case '#':
      lock_abonnee(unr, sname, w1);
      break;

    break;

    default:
      Result = false;
      break;
    }
  }
  return Result;
}



/* ------------------------------------------------------------------------------------------ */

/* der REDIST - Server...                        */
/* SP LOCBBS, SP LOCAL, S REGION, S NATION       */
/* Wenn in der Titelzeile zu Beginn ein # steht, */
/* ist das angefuegte Wort als Rubrikangabe      */
/* zu interpretieren, ansonsten gehts an ALL     */
/* Der Absender bekommt eine Bestaetigung        */
/* Die Absender-R:-Line wird an die neue Mail    */
/* angehaengt                                    */

#define blocksize       16384

boolean do_redist(Char *absender, Char *dest, Char *betreff_, Char *tname,
		  long offset)
{
  boolean Result;
  Char betreff[256];

  short k, h, x;
  long seekp;
  Char hs[256], newb[256], newmbx[256];
  Char lastr[256], sendbbs[256];
  Char STR7[256];

  strcpy(betreff, betreff_);
  redserv_sem++;
  Result = false;
  if (exist(tname)) {
    if (callsign(absender)) {
      *newmbx = '\0';
      if (!strcmp(dest, "LOCBBS"))
	strcpy(newmbx, Console_call);
      else if (!strcmp(dest, "LOCAL"))
	strcpy(newmbx, redlocal);
      else if (!strcmp(dest, "REGION"))
	strcpy(newmbx, redregion);
      else if (!strcmp(dest, "NATION"))
	strcpy(newmbx, rednation);

      if (*newmbx != '\0') {
	strcpy(newb, "ALL");
	if (*reddefboard != '\0')
	  strcpy(newb, reddefboard);
	if (betreff[0] == '#') {
	  get_word(betreff, hs);
	  strdelete((void *)hs, 1, 1);
	  cut(hs, 8);
	  upper(hs);
	  if (valid_boardname(hs) && !callsign(hs))
	    strcpy(newb, hs);
	}

	if (*betreff == '\0')
	  strcpy(betreff, "REDIST MSG");

	sprintf(hs, "%simport%c001", newmaildir, extsep);
	validate(hs);
	k = sfcreate(hs, FC_FILE);
	if (k >= minhandle) {
	  string_to_file(&k, Console_call, true);   /* frombox */
	  string_to_file(&k, absender, true);   /* absender */
	  string_to_file(&k, newb, true);   /* an */
	  string_to_file(&k, newmbx, true);   /* mbx */
	  if (redlifetime >= 0)
	    sprintf(hs, "%ld", redlifetime);
	  else
	    strcpy(hs, "30");
	  rspacing(hs, 30);
	  string_to_file(&k, hs, true);   /* lt */
	  strcpy(hs, "                   ");
	  string_to_file(&k, hs, true);   /* BID */
	  string_to_file(&k, betreff, true);   /* subject */

	  h = sfopen(tname, FO_READ);
	  if (h >= minhandle) {
	    Result = true;
	    seekp = sfseek(offset, h, SFSEEKCUR);
	    *lastr = '\0';
	    *sendbbs = '\0';
	    while (file_to_string(h, hs) && strpos2(hs, "R:", 1) == 1) {
	      strcpy(lastr, hs);
	      seekp = sfseek(0, h, SFSEEKCUR);
	    }

	    sfclose(&h);

	    x = strpos2(lastr, "]", 1);
	    if (x > 0)
	      cut(lastr, x + 1);
	    x = strpos2(lastr, "$:", 1);
		/* sollte eigentlich nicht vorkommen */
	    if (x > 0)
	      cut(lastr, x - 1);

	    x = strpos2(lastr, "@", 1);
	    if (x > 0) {
	      strsub(sendbbs, lastr, x + 1, 7);
	      if (sendbbs[0] == ':')
		strdelete((void *)sendbbs, 1, 1);
	      unhpath(sendbbs, sendbbs);
	      if (!callsign(sendbbs))
		*sendbbs = '\0';
	    }

	    string_to_file(&k, lastr, true);

	    app_file2(tname, k, seekp, false);

	    sfclose(&k);

	    strcpy(hs, absender);
	    if (*sendbbs != '\0')
	      sprintf(hs + strlen(hs), "@%s", sendbbs);
	    sprintf(hs + strlen(hs), " used redist server %s (%s@%s)",
		    dest, newb, newmbx);
	    append_profile(-6, hs);

	    if (*sendbbs != '\0') {
	      sprintf(hs, "%simport%c001", newmaildir, extsep);
	      validate(hs);
	      k = sfcreate(hs, FC_FILE);
	      if (k >= minhandle) {
		string_to_file(&k, Console_call, true);   /* frombox */
		string_to_file(&k, Console_call, true);   /* absender */
		string_to_file(&k, absender, true);   /* an */
		string_to_file(&k, sendbbs, true);   /* mbx */
		*hs = '\0';
		rspacing(hs, 30);
		string_to_file(&k, hs, true);   /* lt */
		strcpy(hs, "                   ");
		string_to_file(&k, hs, true);   /* BID */
		strcpy(hs, "ACK:REDIST server acknowledged");
		string_to_file(&k, hs, true);   /* subject */
		sprintf(hs, "Mail delivered to %s@%s", newb, newmbx);
		string_to_file(&k, hs, true);
		sfclose(&k);
	      }

	    }

	    sprintf(STR7, "%simport%c%c", newmaildir, extsep, allquant);
	    sort_new_mail(-1, STR7, Console_call);

	  } else
	    sfclosedel(&k);


	}

      }
    }

  }
  redserv_sem--;
  return Result;
}

#undef blocksize





void _box_serv_init(void)
{
  static int _was_initialized = 0;
  if (_was_initialized++)
    return;
  serv_sem = 0;
  redserv_sem = 0;

}



/* End. */
