/* Output from p2c, the Pascal-to-C translator */
/* From input file "box_tim.p" */


/************************************************************/
/*                                                          */
/* DigiPoint SourceCode                                     */
/*                                                          */
/* Copyright (c) 1991-1997 Joachim Schurig, DL8HBS, Berlin  */
/*                                                          */
/* For license details see documentation                    */
/*                                                          */
/************************************************************/


#include "defs.h"
#include <unistd.h>

#define BOX_TIM_G
#include "box_tim.h"


#ifndef TOOLS_H
#include "tools.h"
#endif

#ifndef SORT_H
#include "sort.h"
#endif

#ifndef MISC_OS_H
#include "misc_os.h"
#endif

#ifndef BOXBCAST_H
#include "boxbcast.h"
#endif

#ifndef YAPP_H
#include "yapp.h"
#endif

#ifndef BOXLOCAL_H
#include "boxlocal.h"
#endif

#ifndef BOX_SEND_H
#include "box_send.h"
#endif

#ifndef BOX_SUB_H
#include "box_sub.h"
#endif

#ifndef BOX_SYS_H
#include "box_sys.h"
#endif

#ifndef BOX_SF_H
#include "box_sf.h"
#endif

#ifndef BOX_H
#include "box.h"
#endif

#ifndef BOX_FILE_H
#include "box_file.h"
#endif

#ifndef BOX_INOU_H
#include "box_inou.h"
#endif

#ifndef BOX_MEM_H
#include "box_mem.h"
#endif

#ifndef BOXFSERV_H
#include "boxfserv.h"
#endif

#ifndef SHELL_H
#include "shell.h"
#endif


/* Wird angesprungen, wenn endlich der Spooler nach Eingabe von QUIT */
/* leergelaufen ist (unter anderem wegen //COMP ON). Beendet den     */
/* Connect zur Box endgueltig.                                       */

void end_boxconnect(short unr)
{
  short s, e;
  boolean bbs;

  if (!boxrange(unr))
    return;
  debug0(3, -1, 150);
  s = user[unr]->tcon;
  e = user[unr]->pchan;
  bbs = user[unr]->f_bbs;
  melde_user_ab(unr, user[unr]->action == 14);
  if (bbs) {
    if (s > 0) {
      boxendbox(s);
      return;
    }
    if (e > 0)
      boxpabortsf(e, true);
    return;
  }
  if (s > 0) {
    boxendbox(s);
    return;
  }
  if (e > 0)
    boxpacketendbox(e);
}


void spoolendcheck(short unr)
{
  userstruct *WITH;

  if (!boxrange(unr))
    return;

  WITH = user[unr];
  if (boxspoolstatus(WITH->tcon, WITH->pchan, -1) <= 0)
    end_boxconnect(unr);
}


void tell_command(Char *call, Char *bid, Char *frage)
{
  short k;
  Char tellname[256];

  if (!callsign(call))
    return;
  if ((unsigned long)strlen(bid) >= 32 || ((1L << strlen(bid)) & 0x1ff8) == 0)
    return;
  if (count_words(frage) < 3)
    return;
  sprintf(tellname, "%sTELLREQ%c001", boxstatdir, extsep);
  validate(tellname);
  k = sfcreate(tellname, FC_FILE);
  if (k < minhandle)
    return;
  string_to_file(&k, call, true);
  string_to_file(&k, bid, true);
  string_to_file(&k, frage, true);
  tell_waiting = true;
  sfclose(&k);
  write_msgid(-1, bid);
}


void stop_tell(short unr)
{
  Char hs[256], mbx[256];

  if (!boxrange(unr))
    return;

  sfclose(&user[unr]->tell);

  if (sfsize(user[unr]->tellfname) <= 300000L) {
    strcpy(mbx, user[unr]->tellmbx);
    if (!gen_sftest2(-1, user[unr]->call, mbx)) {
      user_mybbs(user[unr]->call, hs);
      if (*hs == '\0')
	strcpy(hs, Console_call);
      strcpy(mbx, hs);
    }

    sprintf(hs, "%s @ %s < %s tell reply from %s",
	    user[unr]->call, mbx, Console_call, Console_call);
    strcpy(user[unr]->input2, user[unr]->tellfname);
    send_check(unr, hs, false, 'P');
  }

  sfdelfile(user[unr]->tellfname);
  user[unr]->tellfname[0] = '\0';
  melde_user_ab(unr, false);
}


boolean tell_processing(Char *tellfile)
{
  boolean Result;
  short unr, tf, x;
  Char telluser[256];
  Char request[256];
  Char mbx[256];
  Char bid[256];

  debug(1, -1, 121, tellfile);
  boxsetbmouse();
  Result = true;

  tf = sfopen(tellfile, FO_READ);
  if (tf < minhandle)
    return Result;
  file_to_string(tf, telluser);
  file_to_string(tf, bid);
  file_to_string(tf, request);
  sfclosedel(&tf);
  sfdelfile(tellfile);
      /* eigentlich ueberfluessig... aber es gab mal Probleme */

  if (!(callsign(telluser) && (unsigned long)strlen(bid) < 32 &&
	((1L << strlen(bid)) & 0x1ff8) != 0))
    return Result;

  delete_brett_by_bid("T", "", bid, false, true);

  x = strlen(request);
  while (x > 0 && request[x - 1] != '@')
    x--;
  if (x > 0) {
    strsub(mbx, request, x + 1, strlen(request) - x);
    cut(request, x - 1);
    del_leadblanks(mbx);
    cut(mbx, 40);
    del_lastblanks(request);

    unr = melde_user_an(telluser, 0, 0, UM_TELLREQ, false);
    if (unr > 0) {
      Result = true;
      strcpy(user[unr]->tellmbx, mbx);
      box_input(unr, false, false, request, true);
    } else
      Result = false;
  }
  boxsetamouse();
  debug(1, -1, 121, "ended (may be continued in background)");
  return Result;
}


void tell_check(void)
{
  short result;
  DTA dirinfo;
  boolean okproc;
  Char STR1[256];

  okproc = true;
  do {
    sprintf(STR1, "%sTELLREQ%c%c", boxstatdir, extsep, allquant);
    result = sffirst(STR1, 0, &dirinfo);
    if (result == 0 && okproc) {
      sprintf(STR1, "%s%s", boxstatdir, dirinfo.d_fname);
      okproc = tell_processing(STR1);
      sprintf(STR1, "%s%s", boxstatdir, dirinfo.d_fname);
      sfdelfile(STR1);
    }
  } while (result == 0 && okproc != false);
  tell_waiting = (result == 0);
}


void do_quit(short unr, boolean abort, boolean verbose)
{
  Char STR1[256];

  if (!boxrange(unr))
    return;

  if (verbose) {
    sprintf(STR1, "%scookies%cdoc", boxsysdir, extsep);
    if (give_cookie(unr, wlnuser, STR1))
      wlnuser0(unr);
    show_stat(unr, unr);
    wlnuser(unr, "73 !");
  }

  boxspoolread();
  if (abort)
    user[unr]->action = 15;
  else
    user[unr]->action = 14;
}


void timeout_check(short unr)
{
  Char hs[256];
  userstruct *WITH;

  if (!boxrange(unr))
    return;
  WITH = user[unr];
  if (!callsign(WITH->call))
    return;
  if (user[unr]->console != false)
    return;
  if (WITH->pchan > 0) {
    if (boxspoolstatus(0, WITH->pchan, -1) > 0)
      WITH->lastatime = clock_.ixtime;
    else if (boxunackframes(WITH->pchan) > 0)
      WITH->lastatime = clock_.ixtime;
  }
  if (WITH->f_bbs || in_sfp(WITH->call)) {
    if (clock_.ixtime - WITH->lastatime < sftimeout * 60 &&
	clock_.ixtime - WITH->lastcmdtime < 3600)
      return;
    if ((unsigned)WITH->action < 32 && ((1L << WITH->action) & 0xc000L) != 0)
    {   /* endgueltig ende */
      if (clock_.ixtime - WITH->lastatime >= sftimeout * 120)
	abort_useroutput(unr);
      return;
    }
    debug(1, unr, 122, "s&f");
    sprintf(hs, "%s: Timeout", user[unr]->call);
    abort_sf(unr, false, hs);
    return;
  }
  if (clock_.ixtime - WITH->lastatime < usertimeout * 60 &&
      clock_.ixtime - WITH->lastcmdtime < 12 * 3600) /* 12 Stunden */
    return;
  if ((unsigned)WITH->action < 32 && ((1L << WITH->action) & 0xc000L) != 0)
      /* rote Karte */
      {  /* dann kam schon ein QUIT/ABORT */
    if (clock_.ixtime - WITH->lastcmdtime >= 13 * 3600) /* 13 Stunden */
      abort_useroutput(unr);
    return;
  }
  WITH->action = 0;
  debug(1, unr, 122, "user");
  wlnuser(unr, "TIMEOUT");
  do_quit(unr, true, false);
}


Static void show_mailbeacon2(Char *ofiname)
{
  short tnc, x;
  long rp;
  uchar *btbuff;
  long btsize;

  boolean found;

  short chan, plen;
  Char hs[256], w[256], hs2[256];
  Char statustext[256];
  Char mailtext[256];
  Char adress[256];
  long rpx;
  short iface;
  Char qrg[256];

  debug(1, 0, 123, "transmitting...");
  boxsetbmouse();
  sprintf(statustext, "< %%u > dpbox v%%v - %s", Console_call);
  strcpy(mailtext, "Mail for :%r");
  strcpy(adress, "MAIL");
  
  tnc = 0;

  if (balisesize > 0) {
    rp = 0;
    do {
      get_line(balisebuf, &rp, balisesize, hs);
      get_word(hs, w);
      upper(w);
      if (!strcmp(w, "STATUSTEXT"))
	strcpy(statustext, hs);
      else if (!strcmp(w, "MAILTEXT"))
	strcpy(mailtext, hs);
    } while (rp < balisesize);
  }

  expand_macro(-1, statustext);
  expand_macro(-1, mailtext);

  sfbread(true, ofiname, &btbuff, &btsize);
  if (btbuff == NULL) {
    btbuff = malloc(4);
    if (btbuff != NULL) {
      strncpy(btbuff, "NONE", 4);
      btsize = 4;
    }
  }
  if (btbuff != NULL) {
    rp = 0;
    *qrg = '\0';
    while (rp < balisesize) {
      found = false;
      get_line(balisebuf, &rp, balisesize, hs);
      upper(hs);
      get_word(hs, w);
      if (!strcmp(w, "QRG")) {
	get_word(hs, w);
	upper(w);
	iface = -1;
	if (find_socket(w, &iface)) {
	  strcpy(adress, hs);
	  strcpy(qrg, w);
	  found = true;
	}
      }
      if (!found)  /* jetzt wird's ernst */
	continue;
      boxpushunproto(tnc);
      boxsetunproto(tnc, adress, iface, qrg);
      chan = boxgettncmonchan(tnc);
      strcpy(hs, statustext);
      if (*hs != '\0')
	boxsendpline(chan, hs, true, iface);
      if (btsize > 0) {  /* Calls senden */
	plen = boxgetpaclen(chan);
	rpx = 0;
	while (rpx < btsize) {
	  *hs = '\0';
	  strcpy(hs2, mailtext);
	  x = strlen(hs2);
	  while (x > 0 && hs2[x - 1] != '\015')
	    x--;
	  if (hs2[x - 1] == '\015') {
	    sprintf(hs, "%.*s", x, hs2);
	    strdelete((void *)hs2, 1, x);
	  }

	  while (strlen(hs) + strlen(hs2) < plen - 9 && rpx < btsize) {
	    if (strlen(hs2) >= 72) {
	      sprintf(hs + strlen(hs), "%s \015", hs2);
	      *hs2 = '\0';
	    }
	    get_line(btbuff, &rpx, btsize, w);
	    if (*hs2 != '\0')
	      sprintf(hs2 + strlen(hs2), " %s", w);
	    else
	      strcpy(hs2, w);
	  }
	  strcat(hs, hs2);
	  boxsendpline(chan, hs, true, iface);
	}

      }
      boxpopunproto(tnc);
    }
    mymfreep(&btbuff);
  }

  boxsetamouse();
}


void show_mailbeacon(void)
{
  short x, ofi, result;
  boolean noch;
  userstruct uf;
  Char ofiname[256];
  Char ofiname2[256];
  Char hs[256];
  DTA dirinfo;
  Char STR1[256];

  debug0(3, 0, 123);
  boxsetbmouse();

  sprintf(ofiname2, "%sBALISE%cTX", tempdir, extsep);

  if (balisenumber == 0) {
    laststartbalise = clock_.ixtime;

    sprintf(ofiname, "%sBALISE%cDIR", tempdir, extsep);

    sfdelfile(ofiname2);

    ofi = sfcreate(ofiname, FC_FILE);
    if (ofi >= minhandle) {
      sprintf(STR1, "%s%c%c%s", indexdir, allquant, extsep, idx_e);
      result = sffirst(STR1, 0, &dirinfo);
      while (result == 0) {
	strcpy(hs, dirinfo.d_fname);
	del_ext(hs);
	cut(hs, 8);
	upper(hs);
	if (callsign(hs))
	  string_to_file(&ofi, hs, true);
	result = sfnext(&dirinfo);
      }
      sfclose(&ofi);
      baliseh1 = sfopen(ofiname, FO_READ);
    }
  }

  ofi = baliseh1;
  if (ofi >= minhandle) {
    if (file_to_string(ofi, hs)) {
      balisenumber++;

      noch = false;
      for (x = 1; x <= maxuser; x++) {   /* user ist grade im sf eingeloggt */
	if (user[x] != NULL) {
	  if (!strcmp(user[x]->call, hs)) {
	    if (user[x]->f_bbs)
	      noch = true;
	  }
	}
      }

      if (!noch && boxcheck(false, hs) > 0) {
	load_userfile(true, false, hs, &uf);
	if (!uf.hidebeacon)
	  append(ofiname2, hs, true);
      }

    } else {
      sfclosedel(&baliseh1);
      sort_file(ofiname2);
      show_mailbeacon2(ofiname2);
      sfdelfile(ofiname2);
      lastbalise = laststartbalise;
      balisenumber = 0;
    }

  } else {
    lastbalise = laststartbalise;
    balisenumber = 0;
    sfdelfile(ofiname2);
  }

  boxsetamouse();
}


void balise_check(void)
{
  if (balisenumber == 0 &&
      (clock_.ixtime - lastbalise >= balisetime ||
       clock_.ixtime - lastbalise < 0))
    show_mailbeacon();
}


void start_mailbeacon_manually(short unr)
{
  long sec;
  Char hs[256];

  if (balisenumber == 0) {
    show_mailbeacon();
    wlnuser(unr, "OK, processing mail beacon");
    return;
  }
  sec = clock_.ixtime - laststartbalise;
  sprintf(hs, "mail beacon generation in process since %ld seconds", sec);
  wlnuser(unr, hs);
}

void start_crawl(short unr, char *par)
{
  int li;
  long stime;
  char w[256];
  
  crawler_exists = exist(crawlname);
  
  if (!crawler_exists) {
    wlnuser(unr, "no crawler installed");
    return;
  }
  
  if (crawl_started != 0) {
    wlnuser(unr, "crawling currently running");
    if (!strcmp(par, "-q")) {
      crawl_started = 0;
      wlnuser(unr, "waiting for stop");
      boxspoolread();
      stime = time(NULL);
      while (crawl_pid > 0
		&& waitpid(crawl_pid, &li, DP_WNOHANG) == 0
		&& time(NULL) - stime < 20) {
      	sleep(1);
      }
      wlnuser(unr, "now stopped");
      crawl_active = false;
    } else {
      wlnuser(unr, "stop with <crawl -q>");
    }
    return;
  } else if (!strcmp(par, "-q")) {
    wlnuser(unr, "crawl not running");
    crawl_active = false;
    update_bidseek;
    wlnuser(unr, "stopped scanning of new files");
    return;
  } else if (!strcmp(par, "-a1")) {
    if (crawl_active) {
      wlnuser(unr, "scanning of new files already active");
      return;
    }
    crawl_active = true;
    update_bidseek;
    wlnuser(unr, "started scanning of new files");
    return;
  } else if (!strcmp(par, "-d")) {
    wlnuser(unr, "OK, will stop and delete crawler and databases");
    crawl_active = false;
    crawl_started = 0;
    sprintf(w, "%s -d %s", crawlname, crawldir);
    add_zombie(my_exec(w), "");
  }
  
  sprintf(w, "%s -d %s", crawlname, crawldir);
  my_system(w);
  crawl_active = false;
  update_bidseek;
  crawl_started = clock_.ixtime;
  crawl_lastchecknum = 0;
  crawl_pid = 0;
  strcpy(crawl_args, par);
  wlnuser(unr, "OK, will start crawling");
}

#define maxrunargs 50
static void process_crawl(void)
{
  boxlogstruct logheader;
  long last, seek;
  int li;
  short handle;
  char *token;
  char fname[81];
  char vname[256];
  char command[256];
  char hs[256];
  short ct;
  indexstruct header;
  char *args[maxrunargs];
  
  if (!crawler_exists) {
    crawl_started = 0;
    crawl_active = false;
    crawl_pid = 0;
    return;
  }
  
  if (crawl_pid > 0) {
    if (waitpid(crawl_pid, &li, DP_WNOHANG) != 0)
      crawl_pid = 0;
    else
      return;
  }
  
  if (crawl_pid == 0) {
    if (disk_full) {
      crawl_started = 0;
      crawl_active = false;
      update_bidseek();
      return;
    }
    
    debug0(4, -1, 209); 

    last = sfsize(boxlog) / sizeof(boxlogstruct);
    if (crawl_lastchecknum >= last) {
      crawl_started = 0;
      crawl_active = true;
      update_bidseek();
      return;
    }

    handle = sfopen(boxlog, FO_READ);
    if (handle < minhandle) {
      crawl_started = 0;
      return;
    }
    
    seek = (crawl_lastchecknum) * sizeof(boxlogstruct);
    if (sfseek(seek, handle, SFSEEKSET) != seek) {
      crawl_started = 0;
      crawl_active = false;
      sfclose(&handle);
      return;
    }
    
    do {
      seek = sfread(handle, sizeof(boxlogstruct), (uchar *)&logheader);
    } while (crawl_lastchecknum++ <= last
             && seek == sizeof(boxlogstruct)
             && (logheader.msgtype != 'B'
             	 || (logheader.deleted == true)
             	 || (!strcmp("Y", logheader.brett))
             	 || (!strcmp("T", logheader.brett))
                 || ((logheader.pmode & (TBIN+T7PLUS)) != 0)));
                 
    sfclose(&handle);
    
    if (seek != sizeof(boxlogstruct)) {
      crawl_started = 0;
      if (crawl_lastchecknum >= last) {
        crawl_active = true;
        update_bidseek();
      }
      return;
    }

    tmpnam(vname);
    handle = sfcreate(vname, FC_FILE);
    if (handle < minhandle)
      return;
    read_brett(-2, handle, logheader.brett, logheader.idxnr, logheader.idxnr,
    		 100, "+BC", "", 0, &header);
    string_to_file(&handle, "", true);
    string_to_file(&handle, logheader.betreff, true);
    string_to_file(&handle, logheader.absender, true);
    string_to_file(&handle, logheader.obrett, true);
    string_to_file(&handle, logheader.brett, true);
    sfclose(&handle);

    if ((crawl_pid = fork())) {
      add_zombie(crawl_pid, vname);
      return;
    }
    
    for (handle = minhandle; handle <= maxhandle; handle++) close(handle);
    setsid();
    dup(0);
    dup(0);
    
    token = crawlname+strlen(crawlname);
    while (token > fname && token[-1] != '/') token--;
    
    for (ct = 0; ct < maxrunargs; ct++)
      args[ct] = NULL;
   
    sprintf(hs, "%ld", header.msgnum + msgnumoffset);
    strcpy(command, crawl_args);
    
    args[0] = token;
    args[1] = "-a";
    args[2] = crawldir;
    args[3] = vname;
    args[4] = hs;
    args[5] = strtok(command, " \t");
    ct = 6;
    do {
      args[ct] = strtok(NULL, " \t");
    } while (args[ct++] != NULL && ct < maxrunargs);
    
    execv(crawlname, args);
    exit(1);
  }
}
#undef maxrunargs

void crawl_message(long msgnum, char *name)
{
  char s[256];

  debug(4, -1, 210, name); 
  if (!crawler_exists || !crawl_active) {
    sfdelfile(name);
    return;
  }
  sprintf(s, "%s -a %s %s %ld",
  		crawlname, crawldir, name, msgnum);
  add_zombie(my_exec(s), name);
}

void query_crawl(short unr, char *query)
{
  char s[256], fname[256];
  
  if (!crawler_exists) {
    wlnuser(unr, "no database");
    return;
  }
    
  tmpnam(fname);
  strcpy(user[unr]->wait_file, fname);
  user[unr]->action = 500;
  sprintf(s, "%s -s %s %s %s",
  		crawlname, crawldir, fname, query);
  user[unr]->wait_pid = my_exec(s);
}

Static long lastxgartime;


Static void chk_xgar(void)
{
  if (lastxgartime == 0) {
    lastxgartime = clock_.ixtime;
    return;
  }

  if (!x_garbage_waiting)
    return;

  if (clock_.ixtime - lastxgartime <= 300) /* 5 Minuten */
    return;

  garbage_collection(true, false, false, false, -1);
  /* Rubrik 'X' aufraeumen */
  lastxgartime = clock_.ixtime;
}



Static void retarded_msg(short unr)
{
  short x, k;
  Char hs[256];
  Char STR1[256];

  x = str2disturb_chan(user[unr]->call);
  if (x <= 0)
    return;
  user[unr]->newmsg = false;
  sprintf(STR1, "%s%s%cMSG", boxstatdir, user[unr]->call, extsep);
  k = sfopen(STR1, FO_READ);
  if (k < minhandle)
    return;
  while (file_to_string(k, hs))
    wlnuser(x, hs);
  sfclosedel(&k);
  show_prompt(x);
}


Static boolean immediate_zombiecheck;


void add_zombie(long pid, char *fname)
{
  zombietype *zz;
  short slen;

  if (pid <= 0)
    return;
  zz = Malloc(sizeof(zombietype));
  if (zz == NULL)
    return;
  zz->pid = pid;
  if ((slen = strlen(fname)) == 0)
    zz->killfile = NULL;
  else {
    if ((zz->killfile = Malloc(slen+1)) != NULL)
      strcpy(zz->killfile, fname);
  }
  if (zombieroot == NULL) {
    zz->next = NULL;
    zombieroot = zz;
  } else {
    zz->next = zombieroot->next;
    zombieroot->next = zz;
  }
  immediate_zombiecheck = true;
}


void kill_zombies(void)
{
  zombietype *zz, *hz, *hz1;
  long ret;
  int li;

  zz = zombieroot;
  hz = NULL;
  while (zz != NULL) {
    ret = waitpid(zz->pid, &li, DP_WNOHANG);
    if (ret != -1 && ret != zz->pid) {
      hz = zz;
      zz = zz->next;
      continue;
    }

    if (zz->killfile != NULL) {
      sfdelfile(zz->killfile);
      Free(zz->killfile);
    }
    
    hz1 = zz;
    zz = zz->next;
    Free(hz1);

    if (hz != NULL)
      hz->next = zz;
    else
      zombieroot = zz;
  }
}

Static void check_unproto_requests(void)
{
  unprotoportstype *hp;

  hp = unprotodefroot->ports;
  if (hp == NULL)
    return;

  if (unproto_final_update > 0) {
    if (clock_.ixtime - unproto_final_update > unprotodefroot->TxInterval) {
      send_final_unproto(); /* append a "<n> !!"  - message */
      unproto_final_update = 0; /* redundant, just for security */
    }
  }
  
  while (hp != NULL) {
    if (hp->RequestActive)
      send_requested_unproto(hp);
    hp = hp->next;
  }
}

void print_dpboxusage(short unr, dpuaproc outputproc)
{
  short scaley = 10;
  short usage[59];
  short users[59];
  short maxusage;
  short maxusers;
  short x, y, ch, uh, uhl;
  double interval, step, faktor_cpu, faktor_users, cmul, umul;
  char s[256];
  
  if (dpboxcpufilled == false) return;
  
  interval = dpboxcpuarraysize / 60;
  step = 0.0;
  maxusage = 0;
  maxusers = 0;
  
  for (x = 0; x < 59; x++) {
    y = step;
    usage[x] = calc_prozent((dpboxcpu[y + 1] - dpboxcpu[y]) / 200,
    				interval*dpboxcpuinterval);
    users[x] = dpboxuserct[y + 1];
    if (usage[x] > maxusage) maxusage = usage[x];
    if (users[x] > maxusers) maxusers = users[x];
    step = step + interval;
  }
  
  if (maxusage > 100) maxusage = 100;
  faktor_cpu = (double)maxusage / 100.0;
  faktor_users = (double)maxusers / (double)maxuser;
  cmul = scaley*faktor_cpu;
  umul = scaley*(maxuser/100)*faktor_users;
  if (cmul < 1.0) cmul = 1.0;
  
  for (x = scaley; x >= 0; x--) {

    ch = (double)x*cmul + 0.5;
    uh = (double)x*umul + 0.5;
    uhl = (double)(x-1)*umul + 0.5;

    if (x == scaley)
      strcpy(s, "%CPU ^");
    else
      sprintf(s, "  %.2d +", ch);
    for (y = 0; y < 59; y++) {
      if (users[y] > uhl && users[y] <= uh)
        strcat(s, ".");
      else {
        if (usage[y] >= ch)
          strcat(s, "*");
        else if (users[y] > uhl)
          strcat(s, ".");
        else
          strcat(s, " ");
      }
    }
    if (x == scaley)
      strcat(s, "^ User");
    else {
      if (uh != uhl)
        sprintf(s + strlen(s), "+ %d", uh);
      else
        strcat(s, "|");
    }
    outputproc(unr, s);
  }
  
  strcpy(s, "     +");
  for (x = 1; x < 60; x++) {
    if (x % 4 == 0)
      strcat(s, "+");
    else
      strcat(s, "-");
  }
  strcat(s, "+");
  outputproc(unr, s);

  strcpy(s, "     15m");
  for (x = 0; x < 56; x++)
    strcat(s, " ");
  strcat(s, "0m");
  outputproc(unr, s);

  outputproc(unr, "                        * = dpbox cpu, . = user");
}

void get_dpboxusage(short *u1, short *u5, short *u15)
{
  long m1, m5, m15, last;

  if (dpboxcpufilled == false) {
    *u1 = 100;
    *u5 = 100;
    *u15 = 100;
    return;
  }
  
  last = dpboxcpu[dpboxcpuarraysize - 1];
  m15 = dpboxcpu[0];
  *u15 = calc_prozent((last - m15) / 200, 15*60);
  m5 = dpboxcpu[dpboxcpuarraysize - (60 / dpboxcpuinterval * 5) - 1];
  *u5 = calc_prozent((last - m5) / 200, 5*60);
  m1 = dpboxcpu[dpboxcpuarraysize - (60 / dpboxcpuinterval) - 1];
  *u1 = calc_prozent((last - m1) / 200, 1*60);
}

Static short lastbatchhour;
Static long ltc1, ltc2, ltc3, ltc4, ltc5, ltc6;
static startup = true;

void box_timing2(long tct)
{
  short unr, x;
  long ret;
  int li;
  Char w[256];
  Char STR1[256], STR7[256];


  if (tct - ltc6 > dpboxcpuinterval*200 || tct - ltc6 < 0) {  /* alle 15 sec */
    ltc6 = tct;
    if (dpboxcpufilled == false) {
      dpboxcpu[0] = get_cpuusage();
      for (x = 1; x < dpboxcpuarraysize; x++) {
        dpboxcpu[x] = dpboxcpu[0];
        dpboxuserct[x - 1] = 0;
      }
      dpboxuserct[dpboxcpuarraysize - 1] = actual_connects();
      dpboxcpufilled = true;
    } else {
      for (x = 1; x < dpboxcpuarraysize; x++) {
        dpboxcpu[x - 1] = dpboxcpu[x];
        dpboxuserct[x - 1] = dpboxuserct[x];
      }
      dpboxcpu[dpboxcpuarraysize - 1] = get_cpuusage();
      dpboxuserct[dpboxcpuarraysize - 1] = actual_connects();
    }
  }

  if (ltc1 == 0) {
    ltc1 = tct;
    ltc2 = tct;
    ltc3 = tct;
    ltc4 = tct;
    ltc5 = tct;
    return;
  }

  if (tct - ltc5 > 492000L || tct - ltc5 < 0) {  /* alle 41 Minuten */
    fill_msgnumarr();
    ltc5 = statclock();
  }

  if (tct - ltc1 > 120000L || tct - ltc1 < 0) {  /* alle 10 Minuten */
    recompile_log(-1);
    recompile_fwd();

    if (clock_.ixtime - lastwpcreate >= wpcreateinterval)
      generate_wp_files();
    sprintf(STR1, "%slostfile%cbox", boxprotodir, extsep);
    chkopenfiles(43200L, STR1);   /* nach 12 Stunden schliessen */
    ltc1 = statclock();
    smode_timer(-1, tct);
    check_disk_full();
    boxisbusy(false);
  }


  if (tct - ltc2 > 12200 || tct - ltc2 < 0) {  /* alle 61 Sekunden */
    if (startup) {
      startup = false;
      sprintf(STR7, "%sstartup%cbat", boxsysdir, extsep);
      run_sysbatch(STR7);
    }
  
    if (!disk_full) {
      sprintf(STR1, "%simport%c%c", newmaildir, extsep, allquant);
      sort_new_mail(-1, STR1, Console_call);
      sprintf(STR1, "%s%c%c%c", impmaildir, allquant, extsep, allquant);
      sort_new_mail(-1, STR1, "-moni-");
    }

    check_routing_timeouts();

    if (sf_allowed)
      check_sftimer();

    if (mail_beacon && balisetime > 0)
      balise_check();

    if (clock_.hour == garbagetime && garbage_done == false && auto_garbage)
      garbage_waiting = true;
    else if (clock_.hour != garbagetime) {
      garbage_waiting = false;
      garbage_done = false;
    }

    if (clock_.hour != lastbatchhour) {
      if (lastbatchhour == -1)
	lastbatchhour = clock_.hour;
      else {
	lastbatchhour = clock_.hour;
	if (lastbatchhour == 0) {
	  badtimecount = 0;
	  readjust_dayly_sfcount();
	}
	sprintf(w, "%ld", lastbatchhour);
	sprintf(STR7, "%shour_%s%cbat", boxsysdir, w, extsep);
	run_sysbatch(STR7);
	sprintf(STR7, "%shour%cbat", boxsysdir, extsep);
	run_sysbatch(STR7);
      }
    }

    if (tell_waiting)
      tell_check();

    if (garbage_waiting) {
      if (auto_garbage) {
	if (!boxgbstop()) {
	  garbage_collection(false, false, false, false, -1);
	  garbage_done = true;
	  garbage_waiting = false;
	} else
	  garbage_waiting = false;
      } else
	garbage_waiting = false;
    }

    ltc2 = statclock();

  }



  if (immediate_extcheck || tct - ltc4 > 200 || tct - ltc4 < 0)
  {  /* alle 1 Sekunde */
    immediate_extcheck = false;
    ltc4 = tct;

    utc_clock();

    if (send_bbsbcast) {
      if (get_boxruntime_l() > 60)
        boxbcasttxtimer();
    }
    
    if (unproto_list && unprotodefroot != NULL)
      check_unproto_requests();

    for (unr = 1; unr <= maxuser; unr++) {
      if (boxrange(unr)) {
	if (user[unr]->trace_to > 0) {
	  if (*user[unr]->tracefract != '\0') {
	    *w = '\0';
	    trace_string(false, unr, user[unr]->trace_to, w, true);
	  }
	}

	if (user[unr]->newmsg)
	  retarded_msg(unr);

	if (user[unr]->action == 96) {
	  if (user[unr]->yapp != NULL) {
	    if (boxspoolstatus(user[unr]->tcon, user[unr]->pchan, -1) <=
		maxuserspool)
	    {
	      if (!read_filepart(unr))
		user[unr]->action = 0;
	    } else if (clock_.ixtime - user[unr]->yapp->touch > 20)
	      sfclose(&user[unr]->yapp->filefd);
	  } else {
	    if (user[unr]->bin == NULL)
	      user[unr]->action = 0;
	    else if (boxspoolstatus(user[unr]->tcon, user[unr]->pchan, -1) <=
		     maxuserspool) {
	      if (!read_filepart(unr))
		user[unr]->action = 0;
	    } else if (clock_.ixtime - user[unr]->bin->touch > 20)
	      sfclose(&user[unr]->bin->filefd);
	  }
	}

	if (user[unr]->wait_pid > 0) {
	  ret = waitpid(user[unr]->wait_pid, &li, DP_WNOHANG);
	  if (ret == -1 || ret == user[unr]->wait_pid) {
	    user[unr]->cputime = get_cpuusage();
	    if (ret == user[unr]->wait_pid)
	      close_shell(unr);

	    user[unr]->wait_pid = -1;
	    boxsetrwmode(user[unr]->pchan, 0);

	    switch (user[unr]->action) {

	    case 71:
	      user[unr]->action = 0;
	      show_sortcheck(unr);
	      show_prompt(unr);
	      break;

	    case 99:
	      user[unr]->action = 0;
	      show_ext_command_result(unr);
	      if (user[unr]->action == 0)
	        show_prompt(unr);
	      break;
	    
	    case 500:
	      user[unr]->action = 0;
	      show_fullcheck(unr);
	      show_prompt(unr);
	      break;
	      
	    }
	    upd_statistik(unr, 0, 0, user[unr]->cputime, get_cpuusage());
	    user[unr]->cputime = 0;

	  }
	}

	if ((unsigned)user[unr]->action < 32 &&
	    ((1L << user[unr]->action) & 0xc000L) != 0)
	  spoolendcheck(unr);

      }

    }
  }

  if (immediate_zombiecheck) {
    kill_zombies();
    immediate_zombiecheck = false;
  }

  if (tct - ltc3 > 6200 || tct - ltc3 < 0) {  /* alle 31 Sekunden */
    dp_watchdog(2, 4711);

    for (unr = 1; unr <= maxuser; unr++) {
      if (boxrange(unr)) {
	if (user[unr]->f_bbs &&
	    (user[unr]->action >= 200 && user[unr]->action <= 205))
	  look_for_mail(unr, true, false);
	else if (user[unr]->f_bbs &&
		 (user[unr]->action >= 300 && user[unr]->action <= 305))
	  send_fbb_proposals(unr, true);
	else
	  timeout_check(unr);

      }

    }

    kill_zombies();
    chk_xgar();
    ltc3 = statclock();
  }


  box_get_next_input();
  if (newmailroot != NULL)
    sort_new_mail4();
  if (balisenumber > 0)
    show_mailbeacon();
  if (new_mybbs_data)
    do_emt(&mybbsseekp);
  if (new_remote_erases)
    check_remote_erase(&remerseekp);

  if (crawl_started != 0)
    process_crawl();

  /* auch in box.pas */

}


void _box_tim_init(void)
{
  static int _was_initialized = 0;
  if (_was_initialized++)
    return;
  baliseh1 = nohandle;
  balisenumber = 0;
  lastbatchhour = -1;
  lastxgartime = 0;
  ltc1 = 0;
  ltc2 = 0;
  ltc3 = 0;
  ltc4 = 0;
  ltc5 = 0;
  ltc6 = 0;
  immediate_zombiecheck = false;
  dpboxcpufilled = false;
  crawl_started = 0;
  crawl_pid = 0;
}



/* End. */
