/* Output from p2c, the Pascal-to-C translator */
/* From input file "status.p" */


/************************************************************/
/*                                                          */
/* DigiPoint SourceCode                                     */
/*                                                          */
/* Copyright (c) 1991-1997 Joachim Schurig, DL8HBS, Berlin  */
/*                                                          */
/* For license details see documentation                    */
/*                                                          */
/************************************************************/


#include "defs.h"

#define STATUS_G
#include "status.h"


#ifndef BOXGLOBL_H
#include "boxglobl.h"
#endif

#ifndef BOX_SYS_H
#include "box_sys.h"
#endif

#ifndef YAPP_H
#include "yapp.h"
#endif

#ifndef BOXLOCAL_H
#include "boxlocal.h"
#endif

#ifndef BOXBCAST_H
#include "boxbcast.h"
#endif

#ifndef BOX_MEM_H
#include "box_mem.h"
#endif

#ifndef BOX_FILE_H
#include "box_file.h"
#endif

#ifndef TOOLS_H
#include "tools.h"
#endif

#ifdef dpmacos
#include <utsname.h>
#endif


#define statbufsize     32767

void free_statp(uchar **p)
{
  if (*p != NULL)
    mymfree(p);
}


Static Char tl[256];
Static uchar *pp;
Static long szz;
Static short lcc;


Static void pl(Char *line)
{
  if (szz < statbufsize - strlen(line) - 2) {
    put_line(pp, &szz, line);
    lcc++;
  }
}

Static void ap(short i, Char *line)
{
  pl(line);
}

static void spp2(char *s)
{
  rspacing(s, 39);
  if (strlen(tl) + strlen(s) > 79) {
    pl(tl);
    strcpy(tl, s);
  } else
    strcat(tl, s);
}

static void sppi(char *s, long l, char *r)
{
  char hs[256];
  
  sprintf(hs, "%-17s: %ld%s", s, l, r);
  spp2(hs);
}

static void sppb(char *s, boolean b)
{
  char hs[256];
  
  if (b)
    sprintf(hs, "%-17s: on", s);
  else
    sprintf(hs, "%-17s: off", s);
  spp2(hs);
}

static void spps(char *s, char *p, char *r)
{
  char hs[256];
  
  sprintf(hs, "%-17s: %s%s", s, p, r);
  spp2(hs);
}

Static long lastsysrunt, lastsysrunres;

long get_sysruntime(void)
{
  short k;
  Char hs[256], w[256];
  short x, y;

  if (clock_.ixtime - lastsysrunt < 15)
    return lastsysrunres;

  lastsysrunres = get_boxruntime_l();

#ifdef dplinux
  k = sfopen("/proc/uptime", FO_READ);
  if (k < minhandle)
    return lastsysrunres;
  file_to_string(k, hs);
  sfclose(&k);
  get_word(hs, w);
  x = strlen(w);
  y = strpos2(w, ".", 1);
  if (y > 0)
    strdelete((void *)w, y, x - y + 1);
  lastsysrunres = str2lint(w);
#endif

  lastsysrunt = clock_.ixtime;
  return lastsysrunres;
}


Static long lastsysltime;
Static Char lastsysload[21];

void get_sysload(Char *s)
{
  short k;
  Char hs[256], w[256];
  short x, y;
  boolean newproc;

  if (clock_.ixtime - lastsysltime < 10) {
    strcpy(s, lastsysload);
    return;
  }

#ifdef dplinux
  k = sfopen("/proc/loadavg", FO_READ);
  if (k >= minhandle) {
    *s = '\0';
    file_to_string(k, hs);
    sfclose(&k);

    for (x = 1; x <= 3; x++) {
      get_word(hs, w);

      y = strpos2(w, ".", 1);
      if (y > 0)
	strdelete((void *)w, y, 1);
      cut(w, 3);
      while (w[0] == '0')
	strdelete((void *)w, 1, 1);

      if (*w == '\0')
	strcpy(w, "0");

      sprintf(s + strlen(s), "%s%% ", w);
    }

    del_lastblanks(s);

  } else
#endif
    strcpy(s, "100% 100% 100%");

  lastsysltime = clock_.ixtime;
  strcpy(lastsysload, s);
}

Static long lastcputime;
Static Char lastcputype[80];
Static Char lastbogomips[80];

void get_cpuinf(Char *cpu, Char *mips)
{
  short k, x;
  Char hs[256];

  if (clock_.ixtime - lastcputime < 100000) {
    strcpy(cpu, lastcputype);
    strcpy(mips, lastbogomips);
    return;
  }
  
  k = nohandle;

#ifdef dplinux
  k = sfopen("/proc/cpuinfo", FO_READ);
  if (k >= minhandle) {
    *hs = '\0';
    while (file_to_string(k, hs) && uspos("cpu", hs) < 1);
    if (uspos("cpu", hs) < 1) goto _L1;
    x = strpos2(hs, ":", 1);
    if (x < 4) goto _L1;
    strdelete(hs, 1, x);
    if (strlen(hs) < 80)
      get_word(hs, lastcputype);

    *hs = '\0';
    while (file_to_string(k, hs) && uspos("BogoMips", hs) < 1);
    if (uspos("BogoMips", hs) < 1) goto _L1;
    x = strpos2(hs, ":", 1);
    if (x < 4) goto _L1;
    strdelete(hs, 1, x);
    if (strlen(hs) < 80)
      get_word(hs, lastbogomips);
  } 
#endif

_L1:
  sfclose(&k);
  lastcputime = clock_.ixtime;
  strcpy(cpu, lastcputype);
  strcpy(mips, lastbogomips);
}


void get_lastsysload(Char *s)
{
  Char hs[256];

  get_sysload(hs);
  get_word(hs, s);
}


void get_sysversion(Char *s)
{
#ifdef dpmacos
  struct utsname name;

  strcpy(s, "?");
  if (!uname(&name))
    sprintf(s, "%s v%s.%s", name.sysname, name.release, name.version);

#else
  short k, x, y;
  boolean nok;

  strcpy(s, "?");
  k = sfopen("/proc/version", FO_READ);
  if (k < minhandle)
    return;
  *s = '\0';
  file_to_string(k, s);
  sfclose(&k);
  do {
    x = strpos2(s, "(", 1);
    y = strpos2(s, ")", 1);
    nok = false;
    if (x > 0 && y > 0 && y > x)
      strdelete((void *)s, x, y - x + 1);
    else
      nok = true;
  } while (!nok);
#endif
  del_mulblanks(s);
  del_lastblanks(s);
}

void get_status(boolean sysop, uchar **p, long *sz)
{
  Char hs[256], w[256], STR1[256];
  short s1, s2, s3;
  boolean owner;

  if (*p == NULL) {
    *p = Malloc(statbufsize);
    owner = true;
  } else
    owner = false;

  if (*p == NULL)
    return;
  *sz = 0;

  pp = *p;
  szz = *sz;
  *tl = '\0';
  lcc = 0;

  sprintf(hs,"dpbox v%s%s, %s, (c) DL8HBS, Joachim Schurig                       ",
              dp_vnr, dp_vnr_sub, dp_date);
  pl(hs);
 #ifdef dpmacos
  pl("parts of code (c) DL4YBG, Mark Wahl");
 #endif
 #ifdef dplinux
  pl("Linux porting (c) DL4YBG, Mark Wahl");
 #endif
  pl("");

  sprintf(hs, "installed by     : %s", Console_call);
  pl(hs);
  pl("");
  sprintf(hs, "date             : %s %s", clock_.datum, clock_.zeit);
  pl(hs);
  sprintf(hs, "ixtime           : %ld sec. since 1.1.1970", clock_.ixtime);
  pl(hs);
  get_boxruntime_s(STR1);
  sprintf(hs, "dpbox runtime    : %s", STR1);
  pl(hs);
  get_dpboxusage(&s1, &s2, &s3);
  sprintf(hs, "dpbox sysload    : %ld%% %ld%% %ld%%", s1, s2, s3);
  pl(hs);
  calc_ixsecs_to_string(get_sysruntime(), STR1);
  sprintf(hs, "system runtime   : %s", STR1);
  pl(hs);
  get_sysload(STR1);
  sprintf(hs, "system load      : %s", STR1);
  pl(hs);
  get_sysversion(STR1);
  sprintf(hs, "system version   : %s", STR1);
  pl(hs);
  pl("");
  
  get_cpuinf(w, STR1);
  sprintf(hs, "cpu type         : %s", w);
  pl(hs);
  sprintf(hs, "bogomips         : %s", STR1);
  pl(hs);

  sprintf(hs, "cpu speed index1 : %ld%% (68000/8Mhz = 100%%)", get_cpu_speed(1));
  pl(hs);
  sprintf(hs, "cpu speed index2 : %ld%% (68000/8Mhz = 100%%)", get_cpu_speed(2));
  pl(hs);
  pl("");

  if (sysop) {
    pl("open files:");
    sfdispfilelist(0, ap);
    pl("");
  }

  if (sysop) {
    pl("bbs connection streams:");
    calc_boxactivity(0, ap);
    pl("");
  }

  if (send_bbsbcast) {
    pl("broadcast transmission streams:");
    show_bcastactivity(0, ap);
  } else
    pl("no bbs broadcast active");
  pl("");

  pl("Parameters:");
  pl("");

  sppi("Free in Infodir", DFree(infodir) / 1024, " MB");
  if (disk_full) spps("Disk Full", "YES", ""); 
  sppi("bidhash", bidhash_active(), " bytes");
  sppi("maxbullids", maxbullids, "");
  sppi("bullidseek", bullidseek, "");
  sppi("bids", sfsize(msgidlog) / 13, "");
  if (sub_bid != 0) sppi("sub_bid", sub_bid, "");
  sppi("actmsgnum", actmsgnum + msgnumoffset, "");
  sppi("hboxhash", hboxhash_active(), " bytes");
  sppi("ttask", ttask * 5, " ms");
  sppb("ufilhide", ufilhide);
  sppb("smart_routing", smart_routing);  
  sppb("small_msgs_first", small_first);
  sppb("gzip", use_gzip(1000000));
  sppb("7plus", *spluspath != '\0');
  sppi("debug level", debug_level, "");
  sppi("erasedelay", erasewait / 86400L, " days");
  sppi("packdelay", packdelay, " days");
  sppi("bullsfwait", bullsfwait / 86400L, " days");
  sppi("bullsfmaxage", bullsfmaxage / 86400L, " days");
  sppi("returntime", returntime / 86400L, " days");
  sppi("retmailsize", retmailmaxbytes, " bytes");
  sppb("auto7plus", auto7plusextract);
  sppb("autobin", autobinextract);
  sppb("request lt", request_lt);
  sppb("create acks", create_acks);
  sppb("authentication", authentinfo);
  sppb("create wp", create_wp);
  sppb("scan all wp", scan_all_wp);
  sppb("m_filter", m_filter);
  sppb("lazy MD2", md2_only_numbers);
  
  if (!multi_master) sppb("multi_master", multi_master);
  
  sppb("guess mybbs", guess_mybbs);

  if (indexcaches != 0) sppi("indexcaches", indexcaches, " PANIC!");
  sppi("maxufcache", maxufcache, "");
  sppi("userinfocachehit", calc_prozent(ufchit, ufchit + ufcmiss), "%");
  sppi("usersftellmode", usersftellmode, "");
  sppi("connect hiscore", hiscore_connects, "");
  sppb("allunproto", allunproto);
  sppi("unproto requests", request_count, "");
  
  if (last_requesttime != 0) {
    ixdatum2string(last_requesttime, w);
    spps("last request at", w, ""); 
  }
  
  sppi("usertimeout", usertimeout, " min");
  sppi("userlifetime", userlifetime, " days");
  sppi("maxuserconnects", maxuserconnects, "");
  sppi("maxread per day", all_maxread_day, " bytes");
  spps("sf connect call", sf_connect_call, "");

  if (*tl != '\0')
    pl(tl);

  *sz = szz;

}


void _status_init(void)
{
  static int _was_initialized = 0;
  if (_was_initialized++)
    return;
  lastsysrunt = 0;
  lastsysrunres = 0;
  lastsysltime = 0;
  lastcputime = 0;
  *lastsysload = '\0';
  strcpy(lastcputype, "unknown");
  strcpy(lastbogomips, lastcputype );
}
