/* Output from p2c, the Pascal-to-C translator */
/* From input file "tools.p" */


/************************************************************/
/*                                                          */
/* DigiPoint SourceCode                                     */
/*                                                          */
/* Copyright (c) 1991-1997 Joachim Schurig, DL8HBS, Berlin  */
/*                                                          */
/* For license details see documentation                    */
/*                                                          */
/************************************************************/


#include "defs.h"

#define TOOLS_G
#include "tools.h"


#ifndef PASTRIX_H
#include "pastrix.h"
#endif

#ifndef CRC_H
#include "crc.h"
#endif

#ifndef SORT_H
#include "sort.h"
#endif

#ifndef DPGLOBAL_H
#include "dpglobal.h"
#endif

#ifndef BOXGLOBL_H
#include "boxglobl.h"
#endif

#include <time.h>
#include <math.h>


Static long cpuspeed, cpuspeed2, cattime, cpudd;

void quick_speed(void)
{
  long x, z, erg;

  erg = get_cpuusage();
  z = 0;
  for (x = 1; x <= 50000L; x++)   /*100% ca. 45*/
    z += x;
  erg = get_cpuusage() - erg;
  fast_machine = (erg < 10);
  cpudd = z;
}


Static void utc_clock_test(void);


Static void calc_speed(void)
{
  long x, z, erg;

  erg = get_cpuusage();
  z = 0;
  for (x = 1; x <= 1000000L; x++)
    z += x;
  cpuspeed = get_cpuusage() - erg;
  erg = get_cpuusage();
  for (x = 1; x <= 600; x++)
    utc_clock_test();
  cpuspeed2 = get_cpuusage() - erg;
  if (cpuspeed == 0)
    cpuspeed = 1;
  if (cpuspeed2 == 0)
    cpuspeed2 = 1;
  cattime = clock_.ixtime;
  cpudd = z;
}


long get_cpu_speed(short mode)
{
  if (cpuspeed == 0 || clock_.ixtime - cattime > cpuspeed)
    calc_speed();
  switch (mode) {

  case 2:
    return (47000L / cpuspeed2);
    break;

  default:
    return (92800L / cpuspeed);
    break;
  }
}


boolean insecure(Char *s)
{
  Char hs[256];

  if (strstr(s, "../") != NULL)
    return true;
  if (strstr(s, "..*") != NULL)
    return true;
  if (strstr(s, ".?/") != NULL)
    return true;
  if (strstr(s, ".?*") != NULL)
    return true;
    
  strcpy(hs, s);
  get_path(hs);
  if (strchr(hs, '*') != NULL)
    return true;
  if (strchr(hs, '?') != NULL)
    return true;
  if (strchr(hs, '~') != NULL)
    return true;
    
  strcpy(hs, s);
  del_path(hs);
  if (strchr(hs, '~') == hs)
    return true;
    
  return false;
}


short calc_prozent(long v1, long v2)
{
  if (v2 > 100000L)
    return (v1 / (v2 / 100));
  else if (v2 > 0)
    return (v1 * 100 / v2);
  else
    return 0;
}


void expand_tabs(Char *hs, short tabsize)
{
  short x, z;
  Char s1[256];

  do {
    x = strpos2(hs, "\t", 1);
    if (x > 0) {
      strdelete((void *)hs, x, 1);
      z = x;
      while (z % tabsize != 0)
	z++;
      z++; 
      *s1 = '\0';
      lspacing(s1, z - x);
      strinsert(s1, (void *)hs, x);
    }
  } while (x != 0);
}


Static void process_backspaces(Char *hs)
{
  short x, l;

  l = strlen(hs);
  if (l < 1 || l > 255)
    return;
  x = 1;
  while (x < l) {
    if (hs[x - 1] != '\b') {
      x++;
      continue;
    }
    strdelete((void *)hs, x, 1);
    l--;
    if (x > 1) {
      strdelete((void *)hs, x - 1, 1);
      l--;
      x--;
    }
  }
}


boolean give_cookie(short x, fdoutproctype outproc, Char *fname)
{
  long fs, a, b, sp, faktor;
  short k, y, lc;
  char delimiter;
  boolean ok;
  Char hs[256];

  fs = sfsize(fname);
  if (fs <= 0)
    return false;
  
  if (fs >= SHORT_MAX) {
    faktor = (fs / SHORT_MAX);
    if (faktor >= SHORT_MAX)
      faktor = SHORT_MAX - 1;  
    do {
      a = (long)dp_randomize(0, faktor);
      b = (long)dp_randomize(0, SHORT_MAX - 1);
      sp = a * SHORT_MAX + b;
    } while (sp < 0 || sp >= fs);
  }
  else
    sp = (long)dp_randomize(0, fs);
    
  k = sfopen(fname, FO_READ);
  if (k < minhandle)
    return false;

  ok = false;
  lc = 0;
  do {
    lc++;
    if (sfseek(sp, k, SFSEEKSET) == sp) {
      y = 0;
      while (file_to_string(k, hs) && hs[0] != '-' && hs[0] != '%' && y < 400)
	y++;

      if (hs[0] == '-')
        delimiter = '-';
      else if (hs[0] == '%')
        delimiter = '%';
      else
        delimiter = '\0';

      if (delimiter != '\0') {
        y = 0;
	while (file_to_string(k, hs) && hs[0] != delimiter && y < 400) {
	  y++;
	  process_backspaces(hs);
	  expand_tabs(hs, 8);
	  outproc(x, hs);
	  ok = true;
	}
      }
      
    }
    
    if (!ok)
      sp = 0;
      
  } while (!(ok || lc > 1));
  
  sfclose(&k);
  
  return ok;
}


void calc_ixsecs_to_string(long l, Char *hs)
{
  long d, h, m, s;

  d = l / 86400L;
  l -= d * 86400L;
  h = l / 3600;
  l -= h * 3600;
  m = l / 60;
  s = l - m * 60;
  sprintf(hs, "%ldd, %.2ld:%.2ld:%.2ld", d, h, m, s);
}


void file_delete(short x, Char *cmd, fdoutproctype outproc)
{
  DTA dirinfo;
  short result, ct, l;
  Char pa[256], dn[256], df[256];
  Char STR1[256];

  ct = 0;
  strcpy(pa, cmd);
  if (insecure(pa))
    outproc(x, "invalid path");
  else {
    sprintf(pa, "%s%s", boxdir, strcpy(STR1, pa));
    l = strlen(boxdir);
    strcpy(df, pa);
    del_path(df);
    get_path(pa);
    sprintf(STR1, "%s%s", pa, df);
    result = sffirst(STR1, 0, &dirinfo);   /* alle normalen Files suchen */
    while (result == 0) {
      sprintf(dn, "%s%s", pa, dirinfo.d_fname);
      sfdelfile(dn);
      ct++;
      strdelete((void *)dn, 1, l);
      if (x >= 0)
	outproc(x, dirinfo.d_fname);
      result = sfnext(&dirinfo);
    }
  }
  if (ct <= 0) {
    outproc(x, "no matching file found");
    return;
  }
  sprintf(dn, "%ld", ct);
  strcat(dn, " file");
  if (ct != 1)
    strcat(dn, "s");
  strcat(dn, " deleted");
  if (x >= 0)
    outproc(x, dn);
}


boolean useq(Char *s1, Char *s2)
/* stolen from p2c.c of David Gillespie */
{
    unsigned char c1, c2;

    while (*s1) {
	if (*s1++ != *s2++) {
	    if (!s2[-1])
		return false;
	    c1 = upcase_(s1[-1]);
	    c2 = upcase_(s2[-1]);
	    if (c1 != c2)
		return false;
	}
    }
    if (*s2)
	return false;
    return true;
}

short uspos(Char *s1, Char *s2)
{
  Char b1[256], b2[256];

  strcpy(b1, s1);
  strcpy(b2, s2);
  upper(b1);
  upper(b2);
  return strpos2(b2, b1, 1);
}


Static void spdputs(short d, short m, short y, Char sep, Char *s)
{
  sprintf(s, "%.2ld%c%.2ld%c%.2ld", d, sep, m, sep, y);
}


Static void conc_date(Char sep, unsigned short date, Char *s)
{
  short d, m, y;

  if (sep == '/')
    Get_DDate(date, &d, &m, &y);
  else
    Get_DTime(date, &d, &m, &y);
  spdputs(d, m, y % 100, sep, s);
}


Static void make_sortdate(unsigned short date, unsigned short time, Char *s)
{
  sprintf(s, "%.10ld", dos2ixtime(date, time));
}


Static void make_sortsize(long size, Char *s)
{
  sprintf(s, "%.10ld", size);
}


Static void make_sortext(Char *ins, Char *s)
{
  get_ext(ins, s);
  rspacing(s, 10);
  cut(s, 10);
}


Static void shorten_dirstring(Char *hs, short maxct)
{
  short x, y, todel;

  x = strlen(hs);
  if (x <= maxct)
    return;

  todel = x - maxct + 2;
  y = 1;
  while (y < x && hs[y - 1] != extsep)
    y++;
  if (y > todel + 2) {
    strdelete((void *)hs, y - todel + 1, todel);
    strinsert("..", (void *)hs, y - todel + 1);
  } else {
    cut(hs, maxct - 2);
    strcat(hs, "..");
  }
}


#define sbufsize        32767*5
#define SBNAME          0
#define SBDATE          1
#define SBSIZE          2
#define SBEXT           3

void file_dir(boolean supervisor, Char *path, Char *options, short x,
	      fdoutproctype outproc)
{

  DTA dirinfo;
  short result, l;
  boolean longdir, xdir, fnums, count;
  short sortby, countfor;
  uchar *sbuf;
  short maxc, sct;
  long sbs, rbs;
  short h, ct, cct;
  Char hs[256], dn[256], s[256], ds[256];
  Char pn[256];
  Char STR1[256], STR7[256];
  Char STR13[8];

  sbuf = Malloc(sbufsize);
  if (sbuf == NULL)
    return;

  sbs = 0;
  maxc = 0;
  count = false;
  countfor = 0;

  strcpy(ds, options);
  upper(ds);
  
  h = strpos2(ds, "-C", 1);
  if (h > 0) {
    strcpy(s, ds);
    strdelete((void *)s, 1, h + 1);
    get_word(s, pn);
    countfor = Str2int(pn);
    count = true;
  }

  if (strpos2(ds, "-DATE", 1) > 0)
    sortby = SBDATE;
  else if (strpos2(ds, "-SIZE", 1) > 0)
    sortby = SBSIZE;
  else if (strpos2(ds, "-EXT", 1) > 0)
    sortby = SBEXT;
  else
    sortby = SBNAME;

  xdir = (count || strpos2(ds, "-X", 1) > 0 && x >= 0);
  longdir = (xdir || strpos2(ds, "-L", 1) > 0);

  strcpy(pn, path);
  get_path(pn);

  if (!count) {
    if (x >= 0 && strpos2(ds, "-I", 1) > 0) {
      sprintf(hs, "%s.index", pn);
      h = sfopen(hs, FO_READ);
      if (h >= minhandle) {
	while (file_to_string(h, hs))
	  outproc(x, hs);
	sfclose(&h);
	outproc(x, "");
      }
    }

    result = sffirst(path, 16, &dirinfo);   /* alle Subdirectories suchen */
    while (result == 0) {
      if (dirinfo.d_attrib == 16)
      {  /* es handelt sich um einen Directoryeintrag */
	strcpy(hs, dirinfo.d_fname);
	if (longdir) {
	  shorten_dirstring(hs, 24);
	  sprintf(hs, "  * %s/", strcpy(STR7, hs));
	  rspacing(hs, 29);
	  strcat(hs, "           ");
	  conc_date('/', dirinfo.d_date, s);
	  strcat(hs, s);
	  conc_date(':', dirinfo.d_time, s);
	  sprintf(hs + strlen(hs), "  %s", s);
	} else {
	  strcat(hs, "/");
	  l = strlen(hs);
	  if (l > maxc)
	    maxc = l;
	}

	switch (sortby) {

	case SBDATE:
	  make_sortdate(dirinfo.d_date, dirinfo.d_time, ds);
	  break;

	case SBSIZE:
	  make_sortsize(dirinfo.d_length, ds);
	  break;

	case SBEXT:
	  make_sortext(dirinfo.d_fname, ds);
	  break;

	default:
	  *ds = '\0';
	  break;
	}
	sprintf(hs, "%s%s", ds, strcpy(STR7, hs));
	if (sbs + strlen(hs) + 1 < sbufsize)
	  put_line(sbuf, &sbs, hs);
      }
      result = sfnext(&dirinfo);
    }

    if (longdir) {
      sort_mem(sbuf, &sbs);
      rbs = 0;
      while (rbs < sbs) {
	get_line(sbuf, &rbs, sbs, hs);
	if (sortby != SBNAME)
	  outproc(x, &hs[10]);
	else
	  outproc(x, hs);
      }

      if (xdir && sbs > 0)
	outproc(x, "");

      sbs = 0;
    }

  }

  result = sffirst(path, 0, &dirinfo);   /* alle normalen Files suchen */
  while (result == 0) {
    if (dirinfo.d_attrib != 16) {
      strcpy(dn, dirinfo.d_fname);
      if (supervisor && !xdir || dn[0] != '.') {
	if (longdir) {
	  if (!count)
	    shorten_dirstring(dn, 25);
	  rspacing(dn, 25);
	  sprintf(dn, "    %s", strcpy(STR7, dn));
	  sprintf(hs, "%ld", dirinfo.d_length);
	  lspacing(hs, 8);
	  sprintf(hs, "%s %s", dn, strcpy(STR1, hs));
	  rspacing(hs, 40);
	  conc_date('/', dirinfo.d_date, s);
	  strcat(hs, s);
	  conc_date(':', dirinfo.d_time, s);
	  sprintf(hs + strlen(hs), "  %s", s);
	} else {
	  strcpy(hs, dn);
	  l = strlen(hs);
	  if (l > maxc)
	    maxc = l;
	}

	switch (sortby) {

	case SBDATE:
	  make_sortdate(dirinfo.d_date, dirinfo.d_time, ds);
	  break;

	case SBSIZE:
	  make_sortsize(dirinfo.d_length, ds);
	  break;

	case SBEXT:
	  make_sortext(dirinfo.d_fname, ds);
	  break;

	default:
	  *ds = '\0';
	  break;
	  
	}
	sprintf(hs, "%s%s", ds, strcpy(STR7, hs));

	if (sbs + strlen(hs) + 1 < sbufsize)
	  put_line(sbuf, &sbs, hs);

      }
    }
    result = sfnext(&dirinfo);
  }

  sort_mem(sbuf, &sbs);

  rbs = 0;
  sct = 0;

  if (!longdir) {
    *s = '\0';
    if (maxc > 78)
      maxc = 78;
  }

  cct = 0;
  fnums = (xdir &&
	   strpos2(path, (sprintf(STR13, "%c%c%c%c",
				  dirsep, allquant, extsep,
				  allquant), STR13), 1) == strlen(path) - 3);

  while (rbs < sbs) {
    get_line(sbuf, &rbs, sbs, hs);
    if (sortby != SBNAME)
      strdelete((void *)hs, 1, 10);
    if (!longdir) {
      rspacing(hs, maxc);
      if (sct + maxc > 78) {
	outproc(x, s);
	sct = maxc;
	strcpy(s, hs);
	continue;
      }
      if (sct == 0) {
	strcpy(s, hs);
	sct = maxc;
      } else {
	sprintf(s + strlen(s), "  %s", hs);
	sct += maxc + 2;
      }
      continue;
    }

    if (count) {
      cct++;
      if (cct == countfor) {
	strdelete((void *)hs, 1, 4);
	get_word(hs, path);
	mymfreep(&sbuf);
	return;
      }
      continue;
    }

    if (fnums) {
      cct++;
      strdelete((void *)hs, 1, 3);
      sprintf(s, "%ld", cct);
      lspacing(s, 3);
      sprintf(hs, "%s%s", s, strcpy(STR1, hs));
    }

    outproc(x, hs);

    if (!xdir)
      continue;

    strdelete((void *)hs, 1, 4);
    get_word(hs, s);
    if (s[0] == '.')
      continue;

    sprintf(hs, "%s.%s", pn, s);
    h = sfopen(hs, FO_READ);
    if (h < minhandle)
      continue;
    for (ct = 1; ct <= 4; ct++) {
      if (file_to_string(h, hs)) {
	sprintf(hs, "    %s", strcpy(STR7, hs));
	outproc(x, hs);
      }
    }
    sfclose(&h);
    outproc(x, "");
  }

  if (!longdir && sct > 0)
    outproc(x, s);

  if (count)
    *path = '\0';
  mymfreep(&sbuf);
}

#undef sbufsize
#undef SBNAME
#undef SBDATE
#undef SBSIZE
#undef SBEXT


short filecp(Char *filea, Char *fileb, Char *root, boolean del_source,
	     short x, fdoutproctype outproc)
{
  short Result;
  short err;
  boolean dest_set_dir, dest_is_dir;
  DTA dirinfo;
  short result, loopct;
  Char fpath[256], fa[256], fb[256], fx[256];
  Result = -1;
  err = 0;

  if (*root != '\0') {
    if (insecure(filea))
      err = -1;
    else if (insecure(fileb))
      err = -1;
    else if (strpos2(filea, root, 1) != 1)
      err = -1;
    else if (strpos2(fileb, root, 1) != 1)
      err = -1;

    if (err != 0) {
      if (x >= 0)
	outproc(x, "no permission");
      return Result;
    }
  }

  strcpy(fx, fileb);
  if (fx[strlen(fx) - 1] == dirsep) {
    strdelete((void *)fx, strlen(fx), 1);
    dest_set_dir = true;
  } else
    dest_set_dir = false;

  dest_is_dir = (sffirst(fx, 16, &dirinfo) == 0 && dirinfo.d_attrib == 16);

  if (dest_set_dir && !dest_is_dir) {
    if (x >= 0)
      outproc(x, "destination is not a directory");
    return Result;
  }

  strcpy(fpath, filea);
  get_path(fpath);

  if (dest_is_dir) {
    sprintf(fb, "%s%c", fx, dirsep);
    if (!strcmp(fb, fpath)) {
      if (x >= 0)
	outproc(x, "invalid operation");
      return Result;
    }
  }

  loopct = 0;
  result = sffirst(filea, 0, &dirinfo);
  while (result == 0 && (loopct == 0 || dest_is_dir)) {
    if (dirinfo.d_attrib != 16) {
      sprintf(fa, "%s%s", fpath, dirinfo.d_fname);
      if (dest_is_dir)
	sprintf(fb, "%s%c%s", fx, dirsep, dirinfo.d_fname);
      else
	strcpy(fb, fx);

      if (x >= 0)
	outproc(x, dirinfo.d_fname);

      if (del_source)
	filemove(fa, fb);
      else
	filecopy(fa, fb);

      if (dest_is_dir)
	Result = 1;
      else
	Result = 0;
      loopct++;
    }
    result = sfnext(&dirinfo);
  }
  return Result;
}


/* Errechnet eine Checksumme ueber einen String       */

uchar calccs(Char *s)
{
  uchar erg;

  erg = 0;

  while (*s != '\0')
    erg += *s++;

  return erg;
}

/* Kopiert und errechnet eine Checksumme ueber einen String       */

uchar strcpycs(register char *s2, register char *s1)
{
  register uchar erg;
  register char ch;

  erg = 0;

  do {
    ch = *s1++;
    erg += ch;
    *s2++ = ch;
  } while (ch != '\0');

  return erg;
}


#define blocksize       8192L

/* Errechnet eine CRC ueber ein File                 */

unsigned short file_crc(short methode, Char *name, unsigned short preload,
			long start, long size)
{
  unsigned short crc;
  short k;
  long fsize, done, cstep, psize, hsize;
  uchar *buf;

  crc = preload;
  fsize = sfsize(name);

  if (size > 0)
    fsize = size;
  if (start > 0) {
    if (size == 0)
      fsize -= start;
  }

  if (fsize <= 0)
    return crc;

  psize = blocksize;
  if (psize > fsize)
    psize = fsize;
  dpgetmem(&buf, psize);
  if (buf == NULL) {
    hsize = maxavail__();
    if (hsize > 0) {
      if (hsize > psize)   /* darf nicht vorkommen */
	hsize = psize;
      psize = hsize;
      dpgetmem(&buf, psize);
    }
  }
  if (buf == NULL)
    return crc;
  k = sfopen(name, FO_READ);
  if (k >= minhandle) {
    if (start > 0)
      sfseek(start, k, SFSEEKSET);
    done = 0;
    cstep = 1;
    while (done < fsize && cstep > 0) {
      cstep = sfread(k, psize, buf);
      if (cstep <= 0)
	break;
      done += cstep;

      switch (methode) {

      case 0:
	crcfcs_buf(buf, cstep, &crc);
	break;

      case 1:
	crc_16_buf(buf, cstep, &crc);
	break;

      case 2:
	crcthp_buf(buf, cstep, &crc);
	break;

      case 3:
	crcfbb_buf(buf, cstep, &crc);
	break;

      case 4:
	checksum8_buf(buf, cstep, &crc);
	break;

      case 5:
	checksum16_buf(buf, cstep, &crc);
	break;

      }
    }
    sfclose(&k);
  }
  dpfreemem(&buf, psize);
  return crc;
}

#undef blocksize


void wochentag(Char *lan, short d, short m, short y, Char *s)
{
  Char hs[256];

  get_language(week_day(d, m, y) + 66, langmemroot, lan, hs);
  cut(hs, 10);
  strcpy(s, hs);
}

boolean compare(Char *w, Char *cmd)
{
  return (strpos2(cmd, w, 1) == 1);
}


void del_tnc3port(Char *callin, Char *callout)
{
  if (callin[1] == ':')
    strsub(callout, callin, 3, strlen(callin) - 2);
  else
    strncpy(callout, callin, 9);
  cut(callout, 9);
}


void del_callextender(Char *callin, Char *callout)
{
  char *p;
  Char h[256];

  strcpy(h, callin);
  p = strchr(h, '-');
  if (p != NULL) *p = '\0';
  if (h[1] == ':')
    strdelete((void *)h, 1, 2);
  cut(h, 6);
  strcpy(callout, h);
}


void get_callextender(Char *callin, Char *callout)
{
  char *p;

  p = strchr(callin, '-');
  if (p == NULL) {
    callout[0] = '\0';
    return;
  }
  strncpy(callout, ++p, 2);
  cut(callout, 2);
}


Static short iscalpha(Char c)
{
  if (isupper(c))
    return 1;
  else if (isdigit(c))
    return 0;
  else if (islower(c))
    return 1;
  else
    return -1;
}


boolean callsign(Char *rubrik)
{
  short l;

  l = strlen(rubrik);
  if (l < 4 || l > 6)
    return false;

  switch (iscalpha(rubrik[0])) {

  case 0:  /* N */
    switch (iscalpha(rubrik[1])) {

    case 0:   /* NN */
      return false;
      break;

    case 1:  /* NA */
      switch (iscalpha(rubrik[2])) {

      case 0:  /* NAN */
	switch (iscalpha(rubrik[3])) {

	case 0:   /* NANN */
	  return false;
	  break;

	case 1:   /* NANA */
	  break;
	}
	break;

      case 1:   /* NAA */
	return false;
	break;

      default:
	return false;
	break;
      }
      break;

    default:
      return false;
      break;
    }
    break;

  case 1:  /* A */
    switch (iscalpha(rubrik[1])) {

    case 0:  /* AN */
      switch (iscalpha(rubrik[2])) {

      case 0:  /* ANN */
	switch (iscalpha(rubrik[3])) {

	case 0:   /* ANNN */
	  return false;
	  break;

	case 1:   /* ANNA */
	  break;

	default:
	  return false;
	  break;
	}
	break;

      case 1:  /* ANA */
	switch (iscalpha(rubrik[3])) {

	case 0:   /* ANAN */
	  return false;
	  break;

	case 1:   /* ANAA */
	  break;

	default:
	  return false;
	  break;
	}
	break;

      default:
	return false;
	break;
      }
      break;

    case 1:  /* AA */
      switch (iscalpha(rubrik[2])) {

      case 0:  /* AAN */
	switch (iscalpha(rubrik[3])) {

	case 0:   /* AANN */
	  return false;
	  break;

	case 1:   /* AANA */
	  break;

	default:
	  return false;
	  break;
	}
	break;

      case 1:
	if (rubrik[2] == 'Q' || rubrik[2] == 'q')
	  return (uspos("REQ", rubrik) == 1);
	return false;   /* AAA */
	break;

      default:
	return false;
	break;
      }
      break;

    default:
      return false;
      break;
    }
    break;

  default:
    return false;
    break;
  }

  if (l >= 5 && iscalpha(rubrik[4]) != 1)
    return false;
  if (l == 6 && iscalpha(rubrik[5]) != 1)
    return false;

  return true;
}


void datum22string(short day, short mon, short year, Char *datestring)
{
  if (day < 10)
    sprintf(datestring, "0%ld", day);
  else
    sprintf(datestring, "%ld", day);
  
  if (mon < 10)
    sprintf(datestring + strlen(datestring), ".0%ld", mon);
  else
    sprintf(datestring + strlen(datestring), ".%ld", mon);

  year = year % 100;
  if (year < 10)
    sprintf(datestring + strlen(datestring), ".0%ld", year);
  else
    sprintf(datestring + strlen(datestring), ".%ld", year);
  cut(datestring, 8);
}

void datum2string(unsigned short datum, Char *datestring)
{
  short day, mon, year;

  Get_DDate(datum, &day, &mon, &year);
  datum22string(day, mon, year, datestring);
}

void ixdatum2string(long datum, Char *datestring)
{
  uchar d, m, y, h, min, s;

  decode_ixtime(datum, &d, &m, &y, &h, &min, &s);
  datum22string(d, m, y, datestring);
}

void zeit22string(short hour, short min, short sec, Char *timestring)
{
  Char hs[256];
  Char STR1[256];

  sprintf(timestring, "%ld", hour);
  if (hour < 10)
    sprintf(timestring, "0%s", strcpy(STR1, timestring));
  sprintf(hs, "%ld", min);
  if (min < 10)
    sprintf(timestring + strlen(timestring), ":0%s", hs);
  else
    sprintf(timestring + strlen(timestring), ":%s", hs);
  sprintf(hs, "%ld", sec);
  if (sec < 10)
    sprintf(timestring + strlen(timestring), ":0%s", hs);
  else
    sprintf(timestring + strlen(timestring), ":%s", hs);
  cut(timestring, 8);
}

void zeit2string(unsigned short zeit, Char *timestring)
{
  short hour, min, sec;

  Get_DTime(zeit, &hour, &min, &sec);
  zeit22string(hour, min, sec, timestring);
}

void dosdt2string(unsigned short date, unsigned short time, Char *timestring)
{
  Char w[30];
  
  datum2string(date, timestring);
  zeit2string(time, w);
  strcat(timestring, " ");
  strcat(timestring, w);
}

void ixzeit2string(long zeit, Char *timestring)
{
  uchar d, m, y, h, min, s;

  decode_ixtime(zeit, &d, &m, &y, &h, &min, &s);
  zeit22string(h, min, s, timestring);
}

void ix2string(long zeit, Char *timestring)
{
  uchar d, m, y, h, min, s;
  Char hs[256];

  decode_ixtime(zeit, &d, &m, &y, &h, &min, &s);
  zeit22string(h, min, s, hs);
  datum22string(d, m, y, timestring);
  strcat(timestring, " ");
  strcat(timestring, hs);
}


unsigned short str2datum(Char *datestring)
{
  short day, mon, year, x;
  boolean reverse;
  Char sep;
  Char hs[256];
  Char STR1[256];
  
  reverse = false;
  x = strpos2(datestring, ".", 1);
  if (x == 0) {
    x = strpos2(datestring, "/", 1);
    if (x == 0) {
      x = strpos2(datestring, "-", 1);
      if (x == 3) {
	reverse = true;
	sep = '-';
      } else
	sep = '\0';
    } else
      sep = '/';
  } else
    sep = '.';
  if ((unsigned)x < 32 && ((1L << x) & 0xc) != 0) {
    sprintf(hs, "%.*s", x - 1, datestring);
    day = Str2int(hs);
    strdelete((void *)datestring, 1, x);
    sprintf(STR1, "%c", sep);
    x = strpos2(datestring, STR1, 1);
    if ((unsigned)x < 32 && ((1L << x) & 0xc) != 0) {
      sprintf(hs, "%.*s", x - 1, datestring);
      mon = Str2int(hs);

      strdelete((void *)datestring, 1, x);
      sprintf(STR1, "%.2s", datestring);
      if (!strcmp(STR1, "19"))
	strsub(hs, datestring, 3, 2);
      else
	sprintf(hs, "%.2s", datestring);
      year = Str2int(hs);
      if (year >= 80 && year <= 99) {
	if (reverse) {
	  x = day;
	  day = mon;
	  mon = x;
	}
	if (mon > 12 && day <= 12) {
	  x = day;
	  day = mon;
	  mon = x;
	}
	if ((unsigned)mon < 32 && ((1L << mon) & 0x1ffe) != 0 &&
	    (unsigned)day < 32 && ((1L << day) & 0xfffffffe) != 0)
	  return (Make_DDate(day, mon, year));
	else
	  return 0;
      } else
	return 0;
    } else
      return 0;
  } else
    return 0;
}


unsigned short str2zeit(Char *timestring)
{
  short hour, min, sec, x;
  Char sep;
  Char hs[256];
  Char STR1[256];
  
  x = strpos2(timestring, ":", 1);
  if (x == 0) {
    x = strpos2(timestring, ".", 1);
    if (x == 0) {
      x = strpos2(timestring, "/", 1);
      if (x == 0) {
	x = strpos2(timestring, "-", 1);
	if (x == 3)
	  sep = '-';
	else
	  sep = '\0';
      } else
	sep = '/';
    } else
      sep = '.';
  } else
    sep = ':';

  if ((unsigned)x < 32 && ((1L << x) & 0xc) != 0) {
    sprintf(hs, "%.*s", x - 1, timestring);
    hour = Str2int(hs);
    strdelete((void *)timestring, 1, x);
    sprintf(STR1, "%c", sep);
    x = strpos2(timestring, STR1, 1);
    if (x == 0)
      x = 3;
    if ((unsigned)x < 32 && ((1L << x) & 0xc) != 0) {
      sprintf(hs, "%.*s", x - 1, timestring);
      min = Str2int(hs);
      strdelete((void *)timestring, 1, x);
      if (strlen(timestring) >= 2) {
	sprintf(hs, "%.2s", timestring);
	sec = Str2int(hs);
      } else
	sec = 0;
      if ((unsigned)hour < 32 && ((1L << hour) & 0xffffffL) != 0 &&
	  (unsigned)min <= 59 && (unsigned)sec <= 59)
	return (Make_DTime(hour, min, sec));
      else
	return 0;
    } else
      return 0;
  } else
    return 0;

}


/******************************************************************** */

long daydiff(unsigned short date1, unsigned short time1, unsigned short date2,
	     unsigned short time2)
{
/* unused */
  short d1, m1, y1, h1, min1, s1, d2, m2, y2, h2, min2, s2;

  Get_DDate(date1, &d1, &m1, &y1);
  Get_DDate(date2, &d2, &m2, &y2);
  Get_DTime(time1, &h1, &min1, &s1);
  Get_DTime(time2, &h2, &min2, &s2);
  return calc_ixtime(d2, m2, y2, h2, min2, s2) - calc_ixtime(d1, m1, y1, h1, min1, s1);
}

Static long ix_ytable[68] = {
  0, 31536000L, 63072000L, 94694400L, 126230400L, 157766400L, 189302400L,
  220924800L, 252460800L, 283996800L, 315532800L, 347155200L, 378691200L,
  410227200L, 441763200L, 473385600L, 504921600L, 536457600L, 567993600L,
  599616000L, 631152000L, 662688000L, 694224000L, 725846400L, 757382400L,
  788918400L, 820454400L, 852076800L, 883612800L, 915148800L, 946684800L,
  978220800L, 1009756800L, 1041292800L, 1072828800L, 1104451200L, 1135987200L,
  1167523200L, 1199059200L, 1230681600L, 1262217600L, 1293753600L,
  1325289600L, 1356912000L, 1388448000L, 1419984000L, 1451520000L,
  1483142400L, 1514678400L, 1546214400L, 1577750400L, 1609372800L,
  1640908800L, 1672444800L, 1703980800L, 1735603200L, 1767139200L,
  1798675200L, 1830211200L, 1861833600L, 1893369600L, 1924905600L,
  1956441600L, 1988064000L, 2019600000L, 2051136000L, 2082672000L, 2114294400L
};

Static long ix_mtable[12] = {
  0, 2678400L, 5097600L, 7776000L, 10368000L, 13046400L, 15638400L, 18316800L,
  20995200L, 23587200L, 26265600L, 28857600L
};


long calc_ixtime(uchar d, uchar m, uchar y, uchar h, uchar mi, uchar s)
{
  long erg;

  if (y < 70 || y > 137)
    return 0;

  if (m < 1 || m > 12)
    return 0;

  erg = ix_ytable[y - 70] + ix_mtable[m - 1] + (d - 1) * 86400L +
	(long)h * 3600 + (long)mi * 60 + (long)s;

  if (m > 2 && (y & 3) == 0 && y != 100)
    erg += 86400L;

  return erg;
}


void decode_ixtime(long ix, uchar *d, uchar *m, uchar *y, uchar *h,
		   uchar *min, uchar *s)
{
  long zsum, offset;

  if (ix > 0) {
    *y = 137;
    while (ix_ytable[*y - 70] > ix)
      (*y)--;

    zsum = ix - ix_ytable[*y - 70];
    *m = 12;
    offset = 0;

    if (zsum > 5097600L && ((*y) & 3) == 0 && *y != 100) {
      zsum -= 86400L;
      offset = 86400L;
    }

    while (ix_mtable[*m - 1] > zsum)
      (*m)--;

    if (*m == 2)
      zsum += offset - ix_mtable[*m - 1];
    else
      zsum -= ix_mtable[*m - 1];

    *d = zsum / 86400L + 1;

    zsum %= 86400L;

    *h = zsum / 3600;
    *min = zsum % 3600 / 60;
    *s = zsum % 60;

    return;
  }

  *d = 1;
  *m = 1;
  *y = 70;
  *h = 0;
  *min = 0;
  *s = 0;
}


long calcfdate(unsigned short date, unsigned short time)
{
  short d, m, y, h, min, s;

  Get_DDate(date, &d, &m, &y);
  Get_DTime(time, &h, &min, &s);
  return (calc_ixtime(d, m, y, h, min, s));
}


long dos2ixtime(unsigned short ddate, unsigned short dtime)
{
  return (calcfdate(ddate, dtime));
}


void ix2dostime(long ix, unsigned short *ddate, unsigned short *dtime)
{
  uchar d, m, y, h, min, s;

  decode_ixtime(ix, &d, &m, &y, &h, &min, &s);
  *ddate = Make_DDate(d, m, y);
  *dtime = Make_DTime(h, min, s);
}


long string2ixtime(Char *ds, Char *ts)
{
  return (dos2ixtime(str2datum(ds), str2zeit(ts)));
}


Static long last_ixtime;
Static uchar last_day, last_mon, last_year;


void utc_clock(void)
{
  clock_.ixtime = sys_ixtime();
  if (last_ixtime == clock_.ixtime)
    return;
  last_ixtime = clock_.ixtime;

  decode_ixtime(clock_.ixtime, &clock_.day, &clock_.mon, &clock_.year,
		&clock_.hour, &clock_.min, &clock_.sec);
  zeit22string(clock_.hour, clock_.min, clock_.sec, clock_.zeit);

  if (last_day == clock_.day && last_mon == clock_.mon &&
      last_year == clock_.year)
    return;

  last_day = clock_.day;
  last_mon = clock_.mon;
  last_year = clock_.year;

  datum22string(clock_.day, clock_.mon, clock_.year, clock_.datum);
  clock_.daystart = calc_ixtime(clock_.day, clock_.mon, clock_.year, 0, 0, 0);
  if (wtag_rsc_call != NULL)
    wtag_rsc_call(clock_.day, clock_.mon, clock_.year, clock_.wochentag);
  else
    *clock_.wochentag = '\0';

}


Static void utc_clock_test(void)
{
  unsigned short ddate, dtime;
  clocktype clock2;
  
  /* nur noch zum Testen der CPU-Speed ... */
  clock2.ixtime = sys_ixtime();
  decode_ixtime(clock2.ixtime, &clock2.day, &clock2.mon, &clock2.year,
		&clock2.hour, &clock2.min, &clock2.sec);
  ddate = Make_DDate(clock2.day, clock2.mon, clock2.year);
  dtime = Make_DTime(clock2.hour, clock2.min, clock2.sec);
  datum2string(ddate, clock2.datum);
  zeit2string(dtime, clock2.zeit);

  if (wtag_rsc_call != NULL)
    wtag_rsc_call(clock2.day, clock2.mon, clock2.year, clock2.wochentag);
  else
    *clock2.wochentag = '\0';
}

void get_language(short nr, languagetyp *root, Char *which, Char *s)
{
  languagetyp *lptr;
  boolean found;
  long rp;
  Char w2[9];

  if (nr <= 0 || nr > maxlanguagelinedefs) {
    strcpy(s, "error: invalid line number");
    return;
  }

  sprintf(w2, "%.3s", which);
  upper(w2);

  if (root == NULL) {
    strcpy(s, "error: no languages loaded");
    return;
  }

  do {

    found = false;
    lptr = root;

    while (lptr != NULL && strcmp(lptr->sprache, w2))
      lptr = lptr->next;

    if (lptr == NULL && !strcmp(w2, "G"))
      lptr = root;

    if (lptr != NULL) {
      rp = 0;
      found = false;
      if (lptr->lct[nr - 1].p != NULL) {
	get_line(lptr->lct[nr - 1].p, &rp, lptr->lct[nr - 1].s, s);
	found = true;
      }
    }

    if (!found) {
      if (!strcmp(w2, "G")) {
	strcpy(s, "error: incorrect language definitions");
	found = true;
      } else
	strcpy(w2, "G");
    }

  } while (!found);

}


/*Loescht geladene Sprachen*/

void free_languages(languagetyp **root)
{
  languagetyp *hptr, *hp2;

  hptr = *root;
  while (hptr != NULL) {
    if (hptr->puffer != NULL)
      mymfreep(&hptr->puffer);
    hp2 = hptr;
    hptr = hptr->next;
    Free(hp2);
  }
  *root = NULL;
}


/* Ordnet ein Call einer Sprachanpassung zu */

void user_language(uchar **root, long *size, Char *fname, Char *call_,
		   Char *lan)
{
  Char call[256];
  long lz;
  boolean found;
  Char zl[256], w[256];

  strcpy(call, call_);
  upper(call);
  strcpy(lan, "G");
  if (*root == NULL)
    sfbread(true, fname, root, size);
  if (*root == NULL)
    return;
  lz = 0;
  found = false;
  while (found == false && lz < *size) {
    get_line(*root, &lz, *size, zl);
    get_word(zl, w);
    upper(w);
    found = (strpos2(call, w, 1) == 1);
  }
  if (found)
    get_word(zl, lan);
  upper(lan);
}


void load_languages(languagetyp **root, Char *pfad)
{
  short x;
  long sz, l;
  uchar *p1;
  languagetyp *hptr, *lptr;
  short result;
  DTA dirinfo;
  Char hs[256], w[256];
  Char sprache[256];
  Char pfad2[256];
  Char extension[256];
  Char STR1[256];

  free_languages(root);
  lptr = NULL;
  strcpy(pfad2, pfad);
  get_path(pfad2);
  result = sffirst(pfad, 0, &dirinfo);
  while (result == 0) {
    strcpy(sprache, dirinfo.d_fname);
    get_ext(sprache, extension);
    del_ext(sprache);
    hptr = Malloc(sizeof(languagetyp));
    if (*root == NULL)
      *root = hptr;
    hptr->next = NULL;
    if (lptr != NULL)
      lptr->next = hptr;
    sprintf(STR1, "%s%s.%s", pfad2, sprache, extension);
    sfbread(true, STR1, &hptr->puffer, &hptr->psize);
    if (hptr->puffer != NULL) {
      cut(sprache, 3);   /*da der user auch nicht mehr angeben kann...*/
      upper(sprache);
      strcpy(hptr->sprache, sprache);
      lptr = hptr;

      for (x = 0; x < maxlanguagelinedefs; x++)
	hptr->lct[x].p = NULL;

      sz = 0;
      while (sz < hptr->psize) {
	p1 = (uchar *)(&hptr->puffer[sz]);
	l = sz;
	get_line(hptr->puffer, &sz, hptr->psize, hs);
	get_word(hs, w);
	x = Str2int(w);
	if (x > 0 && x <= maxlanguagelinedefs && *hs != '\0') {
	  l = hptr->psize - l - strlen(w) - 1;
	  if (l > 0) {
	    hptr->lct[x - 1].p = (uchar *)(&p1[strlen(w) + 1]);
	    hptr->lct[x - 1].s = l;
	  }
	}
      }

    } else
      Free(hptr);
    result = sfnext(&dirinfo);
  }
}


void stripcr(Char *fn)
{
  short k, h;
  Char l[256], fn2[256];
  boolean bin, ok;
  uchar *p;
  long ps, err, fp1, fp2;

  ok = false;

  strcpy(fn2, fn);
  validate(fn2);

  k = sfopen(fn, FO_READ);
  if (k < minhandle)
    return;
  h = sfcreate(fn2, FC_FILE);
  if (h >= minhandle) {
    bin = false;
    ok = true;

    while (!bin && file_to_string(k, l)) {
      bin = (strpos2(l, "#BIN#", 1) == 1);
      string_to_file(&h, l, true);
    }

    if (bin) {
      fp1 = sfseek(0, k, SFSEEKCUR);
      fp2 = sfseek(0, k, SFSEEKEND);
      ps = fp2 - fp1 + 1;
      sfseek(fp1, k, SFSEEKSET);
      p = Malloc(ps);
      if (p != NULL) {
	err = sfread(k, ps, p);
	sfwrite(h, err, p);
	mymfree(&p);
      } else
	ok = false;
    }

    sfclose(&h);
  }

  sfclose(&k);

  if (ok) {
    sfdelfile(fn);
    sfrename(fn2, fn);
  }

}


boolean get_fileline(Char *fn, short line, Char *l)
{
  short k, c;

  *l = '\0';
  k = sfopen(fn, FO_READ);
  if (k < minhandle)
    return false;
  c = 1;
  while (file_to_string(k, l) && c < line)
    c++;
  sfclose(&k);
  return (c == line);
}


boolean get_keyline(Char *fn, Char *key, boolean casesense, Char *l)
{
  boolean Result;
  short k;
  boolean ok;
  Char l1[256], l2[256], k1[256];

  Result = false;
  *l = '\0';
  k = sfopen(fn, FO_READ);
  if (k < minhandle)
    return Result;
  if (casesense) {
    while (file_to_string(k, l) && strpos2(l, key, 1) != 1) ;
    Result = (strpos2(l, key, 1) == 1);
  } else {
    strcpy(k1, key);
    upper(k1);
    ok = false;
    while (!ok && file_to_string(k, l)) {
      strcpy(l1, l);
      upper(l1);
      get_word(l1, l2);
      ok = (strcmp(k1, l2) == 0);
    }
    Result = ok;

  }
  sfclose(&k);
  return Result;
}


boolean replace_keyline(Char *fn, Char *key, boolean casesense, Char *e)
{
  boolean Result;
  short k, h;
  boolean ok;
  Char l[256], l1[256], l2[256], k1[256];
  Char fn2[256];

  Result = false;

  strcpy(fn2, fn);
  validate(fn2);

  k = sfopen(fn, FO_READ);
  if (k < minhandle)
    return Result;
  h = sfcreate(fn2, FC_FILE);
  if (h >= minhandle) {
    if (casesense) {
      while (file_to_string(k, l) && strpos2(l, key, 1) != 1)
	string_to_file(&h, l, true);
      Result = (strpos2(l, key, 1) == 1);
      string_to_file(&h, e, true);
      while (file_to_string(k, l))
	string_to_file(&h, l, true);
    } else {
      strcpy(k1, key);
      upper(k1);
      ok = false;
      while (!ok && file_to_string(k, l)) {
	strcpy(l1, l);
	upper(l1);
	get_word(l1, l2);
	ok = (strcmp(k1, l2) == 0);
	if (!ok)
	  string_to_file(&h, l, true);
      }
      Result = ok;
      string_to_file(&h, e, true);
      while (file_to_string(k, l))
	string_to_file(&h, l, true);
    }
    sfclose(&h);
  }
  sfclose(&k);
  if (exist(fn2)) {
    sfdelfile(fn);
    sfrename(fn2, fn);
  }
  return Result;
}

/* ---------------- MD5 computation ------------------ */

/* MD5C.C - RSA Data Security, Inc., MD5 message-digest algorithm
 */

/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
rights reserved.

License to copy and use this software is granted provided that it
is identified as the "RSA Data Security, Inc. MD5 Message-Digest
Algorithm" in all material mentioning or referencing this software
or this function.

License is also granted to make and use derivative works provided
that such works are identified as "derived from the RSA Data
Security, Inc. MD5 Message-Digest Algorithm" in all material
mentioning or referencing the derived work.

RSA Data Security, Inc. makes no representations concerning either
the merchantability of this software or the suitability of this
software for any particular purpose. It is provided "as is"
without express or implied warranty of any kind.

These notices must be retained in any copies of any part of this
documentation and/or software.
 */

/* PROTOTYPES should be set to one if and only if the compiler supports
  function argument prototyping.
The following makes PROTOTYPES default to 0 if it has not already
  been defined with C compiler flags.
 */
#ifndef PROTOTYPES
#define PROTOTYPES 0
#endif

/* POINTER defines a generic pointer type */
typedef unsigned char *POINTER;

/* UINT2 defines a two byte word */
typedef unsigned short int UINT2;

/* UINT4 defines a four byte word */
typedef unsigned long int UINT4;

/* PROTO_LIST is defined depending on how PROTOTYPES is defined above.
If using PROTOTYPES, then PROTO_LIST returns the list, otherwise it
  returns an empty list.
 */
#if PROTOTYPES
#define PROTO_LIST(list) list
#else
#define PROTO_LIST(list) ()
#endif

/* MD5 context. */
typedef struct {
  UINT4 state[4];                                   /* state (ABCD) */
  UINT4 count[2];        /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];                         /* input buffer */
} MD5_CTX;

/* Constants for MD5Transform routine.
 */
#define S11 7
#define S12 12
#define S13 17
#define S14 22
#define S21 5
#define S22 9
#define S23 14
#define S24 20
#define S31 4
#define S32 11
#define S33 16
#define S34 23
#define S41 6
#define S42 10
#define S43 15
#define S44 21

static void MD5Transform PROTO_LIST ((UINT4 [4], unsigned char [64]));
static void MD5Encode PROTO_LIST
  ((unsigned char *, UINT4 *, unsigned int));
static void MD5Decode PROTO_LIST
  ((UINT4 *, unsigned char *, unsigned int));

static unsigned char PADDING_MD5[64] = {
  0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

/* F, G, H and I are basic MD5 functions.
 */
#define F(x, y, z) (((x) & (y)) | ((~x) & (z)))
#define G(x, y, z) (((x) & (z)) | ((y) & (~z)))
#define H(x, y, z) ((x) ^ (y) ^ (z))
#define I(x, y, z) ((y) ^ ((x) | (~z)))

/* ROTATE_LEFT rotates x left n bits.
 */
#define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32-(n))))

/* FF, GG, HH, and II transformations for rounds 1, 2, 3, and 4.
Rotation is separate from addition to prevent recomputation.
 */
#define FF(a, b, c, d, x, s, ac) { \
 (a) += F ((b), (c), (d)) + (x) + (UINT4)(ac); \
 (a) = ROTATE_LEFT ((a), (s)); \
 (a) += (b); \
  }
#define GG(a, b, c, d, x, s, ac) { \
 (a) += G ((b), (c), (d)) + (x) + (UINT4)(ac); \
 (a) = ROTATE_LEFT ((a), (s)); \
 (a) += (b); \
  }
#define HH(a, b, c, d, x, s, ac) { \
 (a) += H ((b), (c), (d)) + (x) + (UINT4)(ac); \
 (a) = ROTATE_LEFT ((a), (s)); \
 (a) += (b); \
  }
#define II(a, b, c, d, x, s, ac) { \
 (a) += I ((b), (c), (d)) + (x) + (UINT4)(ac); \
 (a) = ROTATE_LEFT ((a), (s)); \
 (a) += (b); \
  }

/* MD5 initialization. Begins an MD5 operation, writing a new context.
 */
void MD5Init (context)
MD5_CTX *context;                                        /* context */
{
  context->count[0] = context->count[1] = 0;
  /* Load magic initialization constants.
*/
  context->state[0] = 0x67452301;
  context->state[1] = 0xefcdab89;
  context->state[2] = 0x98badcfe;
  context->state[3] = 0x10325476;
}

/* MD5 block update operation. Continues an MD5 message-digest
  operation, processing another message block, and updating the
  context.
 */
void MD5Update (context, input, inputLen)
MD5_CTX *context;                                        /* context */
unsigned char *input;                                /* input block */
unsigned int inputLen;                     /* length of input block */
{
  unsigned int i, index, partLen;

  /* Compute number of bytes mod 64 */
  index = (unsigned int)((context->count[0] >> 3) & 0x3F);

  /* Update number of bits */
  if ((context->count[0] += ((UINT4)inputLen << 3))
   < ((UINT4)inputLen << 3))
 context->count[1]++;
  context->count[1] += ((UINT4)inputLen >> 29);

  partLen = 64 - index;

  /* Transform as many times as possible.
*/
  if (inputLen >= partLen) {
 memcpy((POINTER)&context->buffer[index], (POINTER)input, partLen);
 MD5Transform (context->state, context->buffer);

 for (i = partLen; i + 63 < inputLen; i += 64)
   MD5Transform (context->state, &input[i]);

 index = 0;
  }
  else
 i = 0;

  /* Buffer remaining input */
  memcpy((POINTER)&context->buffer[index], (POINTER)&input[i], inputLen-i);
}

/* MD5 finalization. Ends an MD5 message-digest operation, writing the
  the message digest and zeroizing the context.
 */
void MD5Final (digest, context)
unsigned char digest[16];                         /* message digest */
MD5_CTX *context;                                       /* context */
{
  unsigned char bits[8];
  unsigned int index, padLen;

  /* Save number of bits */
  MD5Encode(bits, context->count, 8);

  /* Pad out to 56 mod 64.
*/
  index = (unsigned int)((context->count[0] >> 3) & 0x3f);
  padLen = (index < 56) ? (56 - index) : (120 - index);
  MD5Update (context, PADDING_MD5, padLen);

  /* Append length (before padding) */
  MD5Update (context, bits, 8);
  /* Store state in digest */
  MD5Encode(digest, context->state, 16);

  /* Zeroize sensitive information.
*/
  memset ((POINTER)context, 0, sizeof (*context));
}

/* MD5 basic transformation. Transforms state based on block.
 */
static void MD5Transform (state, block)
UINT4 state[4];
unsigned char block[64];
{
  UINT4 a = state[0], b = state[1], c = state[2], d = state[3], x[16];

  MD5Decode (x, block, 64);

  /* Round 1 */
  FF (a, b, c, d, x[ 0], S11, 0xd76aa478); /* 1 */
  FF (d, a, b, c, x[ 1], S12, 0xe8c7b756); /* 2 */
  FF (c, d, a, b, x[ 2], S13, 0x242070db); /* 3 */
  FF (b, c, d, a, x[ 3], S14, 0xc1bdceee); /* 4 */
  FF (a, b, c, d, x[ 4], S11, 0xf57c0faf); /* 5 */
  FF (d, a, b, c, x[ 5], S12, 0x4787c62a); /* 6 */
  FF (c, d, a, b, x[ 6], S13, 0xa8304613); /* 7 */
  FF (b, c, d, a, x[ 7], S14, 0xfd469501); /* 8 */
  FF (a, b, c, d, x[ 8], S11, 0x698098d8); /* 9 */
  FF (d, a, b, c, x[ 9], S12, 0x8b44f7af); /* 10 */
  FF (c, d, a, b, x[10], S13, 0xffff5bb1); /* 11 */
  FF (b, c, d, a, x[11], S14, 0x895cd7be); /* 12 */
  FF (a, b, c, d, x[12], S11, 0x6b901122); /* 13 */
  FF (d, a, b, c, x[13], S12, 0xfd987193); /* 14 */
  FF (c, d, a, b, x[14], S13, 0xa679438e); /* 15 */
  FF (b, c, d, a, x[15], S14, 0x49b40821); /* 16 */

 /* Round 2 */
  GG (a, b, c, d, x[ 1], S21, 0xf61e2562); /* 17 */
  GG (d, a, b, c, x[ 6], S22, 0xc040b340); /* 18 */
  GG (c, d, a, b, x[11], S23, 0x265e5a51); /* 19 */
  GG (b, c, d, a, x[ 0], S24, 0xe9b6c7aa); /* 20 */
  GG (a, b, c, d, x[ 5], S21, 0xd62f105d); /* 21 */
  GG (d, a, b, c, x[10], S22,  0x2441453); /* 22 */
  GG (c, d, a, b, x[15], S23, 0xd8a1e681); /* 23 */
  GG (b, c, d, a, x[ 4], S24, 0xe7d3fbc8); /* 24 */
  GG (a, b, c, d, x[ 9], S21, 0x21e1cde6); /* 25 */
  GG (d, a, b, c, x[14], S22, 0xc33707d6); /* 26 */
  GG (c, d, a, b, x[ 3], S23, 0xf4d50d87); /* 27 */
  GG (b, c, d, a, x[ 8], S24, 0x455a14ed); /* 28 */
  GG (a, b, c, d, x[13], S21, 0xa9e3e905); /* 29 */
  GG (d, a, b, c, x[ 2], S22, 0xfcefa3f8); /* 30 */
  GG (c, d, a, b, x[ 7], S23, 0x676f02d9); /* 31 */
  GG (b, c, d, a, x[12], S24, 0x8d2a4c8a); /* 32 */

  /* Round 3 */
  HH (a, b, c, d, x[ 5], S31, 0xfffa3942); /* 33 */
  HH (d, a, b, c, x[ 8], S32, 0x8771f681); /* 34 */
  HH (c, d, a, b, x[11], S33, 0x6d9d6122); /* 35 */
  HH (b, c, d, a, x[14], S34, 0xfde5380c); /* 36 */
  HH (a, b, c, d, x[ 1], S31, 0xa4beea44); /* 37 */
  HH (d, a, b, c, x[ 4], S32, 0x4bdecfa9); /* 38 */
  HH (c, d, a, b, x[ 7], S33, 0xf6bb4b60); /* 39 */
  HH (b, c, d, a, x[10], S34, 0xbebfbc70); /* 40 */
  HH (a, b, c, d, x[13], S31, 0x289b7ec6); /* 41 */
  HH (d, a, b, c, x[ 0], S32, 0xeaa127fa); /* 42 */
  HH (c, d, a, b, x[ 3], S33, 0xd4ef3085); /* 43 */
  HH (b, c, d, a, x[ 6], S34,  0x4881d05); /* 44 */
  HH (a, b, c, d, x[ 9], S31, 0xd9d4d039); /* 45 */
  HH (d, a, b, c, x[12], S32, 0xe6db99e5); /* 46 */
  HH (c, d, a, b, x[15], S33, 0x1fa27cf8); /* 47 */
  HH (b, c, d, a, x[ 2], S34, 0xc4ac5665); /* 48 */

  /* Round 4 */
  II (a, b, c, d, x[ 0], S41, 0xf4292244); /* 49 */
  II (d, a, b, c, x[ 7], S42, 0x432aff97); /* 50 */
  II (c, d, a, b, x[14], S43, 0xab9423a7); /* 51 */
  II (b, c, d, a, x[ 5], S44, 0xfc93a039); /* 52 */
  II (a, b, c, d, x[12], S41, 0x655b59c3); /* 53 */
  II (d, a, b, c, x[ 3], S42, 0x8f0ccc92); /* 54 */
  II (c, d, a, b, x[10], S43, 0xffeff47d); /* 55 */
  II (b, c, d, a, x[ 1], S44, 0x85845dd1); /* 56 */
  II (a, b, c, d, x[ 8], S41, 0x6fa87e4f); /* 57 */
  II (d, a, b, c, x[15], S42, 0xfe2ce6e0); /* 58 */
  II (c, d, a, b, x[ 6], S43, 0xa3014314); /* 59 */
  II (b, c, d, a, x[13], S44, 0x4e0811a1); /* 60 */
  II (a, b, c, d, x[ 4], S41, 0xf7537e82); /* 61 */
  II (d, a, b, c, x[11], S42, 0xbd3af235); /* 62 */
  II (c, d, a, b, x[ 2], S43, 0x2ad7d2bb); /* 63 */
  II (b, c, d, a, x[ 9], S44, 0xeb86d391); /* 64 */

  state[0] += a;
  state[1] += b;
  state[2] += c;
  state[3] += d;

  /* Zeroize sensitive information.
*/
  memset ((POINTER)x, 0, sizeof (x));
}

/* Encodes input (UINT4) into output (unsigned char). Assumes len is
  a multiple of 4.
 */
static void MD5Encode (output, input, len)
unsigned char *output;
UINT4 *input;
unsigned int len;
{
  unsigned int i, j;

  for (i = 0, j = 0; j < len; i++, j += 4) {
 output[j] = (unsigned char)(input[i] & 0xff);
 output[j+1] = (unsigned char)((input[i] >> 8) & 0xff);
 output[j+2] = (unsigned char)((input[i] >> 16) & 0xff);
 output[j+3] = (unsigned char)((input[i] >> 24) & 0xff);
  }
}

/* Decodes input (unsigned char) into output (UINT4). Assumes len is
  a multiple of 4.
 */
static void MD5Decode (output, input, len)
UINT4 *output;
unsigned char *input;
unsigned int len;
{
  unsigned int i, j;

  for (i = 0, j = 0; j < len; i++, j += 4)
 output[i] = ((UINT4)input[j]) | (((UINT4)input[j+1]) << 8) |
   (((UINT4)input[j+2]) << 16) | (((UINT4)input[j+3]) << 24);
}





/* --------------------- MD2 computation ----------------------------- */



/* ------- start of RSA copyrighted code --------- */

/* some changes were made by Joachim Schurig 28/04/96 to encapsulate
   the code in PASCAL */

/*  Copyright (C) 1990-2, RSA Data Security, Inc. Created 1990. All
    rights reserved.

    License to copy and use this software is granted for
    non-commercial Internet Privacy-Enhanced Mail provided that it is
    identified as the "RSA Data Security, Inc. MD2 Message Digest
    Algorithm" in all material mentioning or referencing this software
    or this function.

    RSA Data Security, Inc. makes no representations concerning either
    the merchantability of this software or the suitability of this
    software for any particular purpose. It is provided "as is"
    without express or implied warranty of any kind.

    These notices must be retained in any copies of any part of this
    documentation and/or software.
  */


typedef uchar MDbarr16[16];

typedef struct MD2_CTX {
  MDbarr16 state, checksum;
  long count;
  MDbarr16 buffer;
} MD2_CTX;


/*
 *  Permutation of 0..255 constructed from the digits of pi. It gives a
 *  "random" nonlinear byte substitution operation.
 */


typedef uchar PI_SUBSTTYPE[256];


typedef MDbarr16 PADDINGTYPE[17];


static PI_SUBSTTYPE PI_SUBST = {
  41, 46, 67, 201, 162, 216, 124, 1, 61, 54, 84, 161, 236, 240, 6, 19, 98,
  167, 5, 243, 192, 199, 115, 140, 152, 147, 43, 217, 188, 76, 130, 202, 30,
  155, 87, 60, 253, 212, 224, 22, 103, 66, 111, 24, 138, 23, 229, 18, 190, 78,
  196, 214, 218, 158, 222, 73, 160, 251, 245, 142, 187, 47, 238, 122, 169,
  104, 121, 145, 21, 178, 7, 63, 148, 194, 16, 137, 11, 34, 95, 33, 128, 127,
  93, 154, 90, 144, 50, 39, 53, 62, 204, 231, 191, 247, 151, 3, 255, 25, 48,
  179, 72, 165, 181, 209, 215, 94, 146, 42, 172, 86, 170, 198, 79, 184, 56,
  210, 150, 164, 125, 182, 118, 252, 107, 226, 156, 116, 4, 241, 69, 157, 112,
  89, 100, 113, 135, 32, 134, 91, 207, 101, 230, 45, 168, 2, 27, 96, 37, 173,
  174, 176, 185, 246, 28, 70, 97, 105, 52, 64, 126, 15, 85, 71, 163, 35, 221,
  81, 175, 58, 195, 92, 249, 206, 186, 197, 234, 38, 44, 83, 13, 110, 133, 40,
  132, 9, 211, 223, 205, 244, 65, 129, 77, 82, 106, 220, 55, 200, 108, 193,
  171, 250, 36, 225, 123, 8, 12, 189, 177, 74, 120, 136, 149, 139, 227, 99,
  232, 109, 233, 203, 213, 254, 59, 0, 29, 57, 242, 239, 183, 14, 102, 88,
  208, 228, 166, 119, 114, 248, 235, 117, 75, 10, 49, 68, 80, 180, 143, 237,
  31, 26, 219, 153, 141, 51, 159, 17, 131, 20
};

static PADDINGTYPE PADDING;
static boolean PADDINGOK;
/* must be initialized with FALSE at program startup (Joachim Schurig) */

/*
 *  initializes the padding tab, cannot be assigned directly in PASCAL code
 *  added by Joachim Schurig
 */

static void init_padding(void)
{
  short x, y;

  PADDING[0][0] = 0;

  for (x = 1; x <= 16; x++) {
    for (y = 0; y < x; y++)
      PADDING[x][y] = x;
  }

  PADDINGOK = true;
}

/* MD2 initialization. Begins an MD2 operation, writing a new context. */

static void MD2Init(MD2_CTX *context)
{
  if (!PADDINGOK)   /* added for PASCAL */
    init_padding();
  context->count = 0;
  memset(context->state, 0, sizeof(MDbarr16));
  memset(context->checksum, 0, sizeof(MDbarr16));
}

/* MD2 basic transformation. Transforms state and updates checksum based on block. */

static void MD2Transform(uchar *state, uchar *checksum, uchar *block)
{
  long i, j, t;
  uchar x[48];

  /* Form encryption block from state, block, state ^ block. */
  memcpy(x, state, 16);
  memcpy(&x[16], block, 16);
  for (i = 0; i <= 15; i++)
    x[i + 32] = state[i] ^ block[i];

  /* Encrypt block (18 rounds). */
  t = 0;
  for (i = 0; i <= 17; i++) {
    for (j = 0; j <= 47; j++) {
      t = x[j] ^ PI_SUBST[t];
      x[j] = t;
    }
    t = (t + i) & 0xff;
  }

  /* Save new state */
  memcpy(state, x, 16);

  /* Update checksum. */
  t = checksum[15];
  for (i = 0; i <= 15; i++) {
    t = checksum[i] ^ PI_SUBST[block[i] ^ t];
    checksum[i] = t;
  }

  /* Zeroize sensitive information. */
  memset(x, 0, sizeof(uchar) * 48);
}

/*
 *  MD2 block update operation. Continues an MD2 message-digest
 *  operation, processing another message block, and updating the
 *  context.
 */

static void MD2Update(MD2_CTX *context, uchar *input, long inputLen)
{
  long i, index, partLen;

  /* Update number of bytes mod 16 */
  index = context->count;
  context->count = (index + inputLen) & 0xf;

  partLen = 16 - index;

  /* Transform as many times as possible. */
  if (inputLen >= partLen) {
    memcpy(&context->buffer[index], input, partLen);
    MD2Transform(context->state, context->checksum, context->buffer);

    i = partLen;
    while (i + 15 < inputLen) {
      MD2Transform(context->state, context->checksum, (uchar *)(&input[i]));
      i += 16;
    }

    index = 0;
  } else
    i = 0;

  /* Buffer remaining input */
  memcpy(&context->buffer[index], (uchar *)(&input[i]), inputLen - i);
}

/*
 *  MD2 finalization. Ends an MD2 message-digest operation, writing the
 *  message digest and zeroizing the context.
 */

static void MD2Final(uchar *digest, MD2_CTX *context)
{
  long index, padLen;

  /* Pad out to multiple of 16 */
  index = context->count;
  padLen = 16 - index;
  MD2Update(context, PADDING[padLen], padLen);

  /* Extend with checksum */
  MD2Update(context, context->checksum, 16);

  /* Store state in digest */
  memcpy(digest, context->state, 16);

  /* Zeroize sensitive information */
  memset((uchar *)context, 0, sizeof(MD2_CTX));
}

/* ------- end of RSA copyrighted code ------- */






void calc_MD5_pw(char *MD5prompt, char *MD5pw, char *MD5result)
{
  MD5_CTX context;
  MDbarr16 digest;
  short i, n, len;
  char c1, c2;
  char buff[256];

  *MD5result = '\0';
  len = strlen(MD5prompt) + strlen(MD5pw);
  if (len > 255)
    return;
  strcpy(buff, MD5prompt);
  strcat(buff, MD5pw);

  MD5Init(&context);

  i = 0;

  while (i < len) {
    if (len - i > 16)
      n = 16;
    else
      n = len - i;
    MD5Update(&context, (uchar *)(&buff[i]), n);
    i += 16;
  }
  MD5Final(digest, &context);

  for (i = 0; i <= 15; i++) {
    int2hchar(digest[i], &c1, &c2);
    sprintf(MD5result + strlen(MD5result), "%c%c", c1, c2);
  }
  lower(MD5result);
}

void calc_MD2_pw(char *MD2prompt, char *MD2pw, char *MD2result)
{
  MD2_CTX context;
  MDbarr16 digest;
  short i, n, len;
  char c1, c2;
  char buff[256];

  *MD2result = '\0';
  len = strlen(MD2prompt) + strlen(MD2pw);
  if (len > 255)
    return;
  strcpy(buff, MD2prompt);
  strcat(buff, MD2pw);

  MD2Init(&context);

  i = 0;

  while (i < len) {
    if (len - i > 16)
      n = 16;
    else
      n = len - i;
    MD2Update(&context, (uchar *)(&buff[i]), n);
    i += 16;
  }
  MD2Final(digest, &context);

  for (i = 0; i <= 15; i++) {
    int2hchar(digest[i], &c1, &c2);
    sprintf(MD2result + strlen(MD2result), "%c%c", c1, c2);
  }
  lower(MD2result);
}

void calc_MD_prompt(boolean only_numbers, char *MDprompt)
{
  short x;
  char c;

  MDprompt[0] = '\0';
  for (x = 1; x <= 10; x++) {
    if (only_numbers) {
      do {
        c = dp_randomize(48, 57);
      } while (!isdigit(c));
    } else {
      do {
        c = dp_randomize(48, 122);
      } while (!isalnum(c));
    }
    sprintf(MDprompt + strlen(MDprompt), "%c", c);
  }
}


/* -------------------------------------------------------------------------------------------- */

/* Ist glaube ich urspruenglich von DL5FBD

(***********************************************************)
(* Procedure Entfernung_Richtung                           *)
(* Die Prozedur dient zur Berechnung von Entfernung und    *)
(* Richtung bei gegebenen geografischen Koordinaten im     *)
(* Gradmass.                                               *)
(* Ergebnis sind Entfernung in Kilometern und Richtung in  *)
(* Grad von QTH1 nach QTH2.                                *)
(* O1,N1 Oestliche Laenge,Noerdliche Breite von QTH1       *)
(* O2,N2 Oestliche Laenge,Noerdliche Breite von QTH2       *)
(***********************************************************)

*/
#ifndef PI
#define PI 3.141592654 /*Kreiskonstante PI    */
#endif

/* Funktion GSIN                                           */
/* Berechnung des Sinus zu einem gegebenen Gradwinkel      */

static double gsin(double winkel)
{
  return sin(winkel*PI/180);
}


/* Funktion GCOS                                           */
/* Berechnung des Cosinus zu einem gegebenen Gradwinkel    */

static double gcos(double winkel)
{
  return cos(winkel*PI/180);
}


/* Funktion ARCGCOS                                        */
/* Berechnung des Gradwinkels zum gegebenen Cosinuswert    */

static double arcgcos(double cosinus)
{
  double arcbog;            /*Hilfsvariable vor Gradumrechnung*/
  double sqrh;

  if (cosinus >= 1.0) return 0;          /*Sonderfall   0 Grad*/
  else if (cosinus <= -1.0) return 180;  /*Sonderfall 180 Grad*/

  sqrh = (1-pow(cosinus, 2));
  if (sqrh < 0.0) sqrh = 0.0;
  arcbog = PI/2-atan(cosinus/(sqrt(sqrh)));
  /*Umrechnung vom Bogenma in Grad*/
  return arcbog*180/PI;
}


void loc_dist(double o1, double n1, double o2, double n2,
              double *entfernung, double *richtung, double *gegenrichtung)
{
  double ew,rv,zs;  /*EW Entfernungswinkel */
                    /*RV vorlaeufige Richtg*/

  if ((o1 == o2) && (n1 == n2)) {
    *entfernung = 0;
    *richtung = 0;
    *gegenrichtung = 0;
    
  } else {
  
    /* Entfernungsberechnung */

    ew = arcgcos(gsin(n1)*gsin(n2)+gcos(n1)*gcos(n2)*gcos(o2-o1));
    *entfernung = 40009/360*ew;

    /* Richtungsberechnung */

    zs  = gcos(n1)*gsin(ew);
    
    if (zs != 0)
      rv = arcgcos((gsin(n2)-gsin(n1)*gcos(ew))/zs);
    else
      rv = 0;
      
    if (gsin(o2-o1) >= 0) *richtung = rv;
    if (gsin(o2-o1) < 0) *richtung = 360-rv;

    zs = gcos(n2)*gsin(ew);
    
    if (zs != 0)
      rv = arcgcos((gsin(n1)-gsin(n2)*gcos(ew))/zs);
    else
      rv = 0;
      
    if (gsin(o1-o2) >= 0) *gegenrichtung = rv;
    else *gegenrichtung = 360-rv;
  }
}

/*********** Ende Entfernung_Richtung ************/



/* Wandeln des WW-Locators in Laengen- und Breitengrad mit Formatueberpruefung */
boolean calc_qth(char *loc_, double *l, double *b)
{
  char loc[256];
  
  if (strlen(loc_) == 6) {      /* zuerst wird die Locatorangabe geprueft */
    strcpy(loc, loc_);
    upper(loc);
    if ((loc[0] <= 'R' && loc[0] >= 'A') && (loc[1] <= 'R' && loc[1] >= 'A')) {
      if ((loc[2] <= '9' && loc[2] >= '0') && (loc[3] <= '9' && loc[3] >= '0')) {
        if ((loc[4] <= 'X' && loc[4] >= 'A') && (loc[5] <= 'X' && loc[5] >= 'A')) {
          *b = ((loc[1] - 65)*10 - 90.0) + (loc[3] - 48.0)
                + ((loc[5] - 65)/24.0 + 1.0/48.0);
          *l = ((loc[0] - 65)*20 - 180.0) + ((loc[2] - 48.0)*2.0)
                + ((loc[4] - 65)/12.0 + 1.0/24.0);
          return true;
        }
      }
    }
  }
  return false;
}

static void substitute(Char *call, Char *subst)
{
  short k;
  Char hs1[256];
  boolean found;
  long subsize;
  uchar *buff;
  long lz;
  
  strcpy(subst, call);
  sprintf(hs1, "%sprefix%csub", boxsysdir, extsep);
  subsize = sfsize(hs1);
  if (subsize > 5) {
    buff = Malloc(subsize);
    if (buff != NULL) {
      k = sfopen(hs1, FO_READ);
      if (k >= minhandle) {
        subsize = sfread(k, subsize, buff);
        sfclose(&k);
        found = false;
        lz = 0;
        while ((lz < subsize) && (!found)) {
          get_line(buff, &lz, subsize, hs1);
          if (strpos2(call, hs1, 1) == 1) {
            found = true;
            strdelete(call, 1, strlen(hs1));
            *hs1 = '\0';
            if (lz < subsize)
              get_line(buff, &lz, subsize, hs1);
            if (strlen(hs1) + strlen(call) <= 8) {
               strcpy(subst, hs1);
               strcat(subst, call);
            } else
              strcpy(subst, hs1);
          } else if (lz < subsize) {
            get_line(buff, &lz, subsize, hs1);
          }
        }
      }
      mymfreep(&buff);
    }
  }
}


boolean prefix(Char *call_, Char *subst, Char *name, double *lon, double *lat,
		short *waz, short *itu, Char *continent)
{
  Char hs[256], call[256];
  boolean found, Result;
  short k;
  long infsize, lz;
  uchar *buff;
  
  Result = false;
  strcpy(call, call_);
  cut(call, 6);
  upper(call);
  substitute(call, subst);
  sprintf(hs, "%sprefix%cinf", boxsysdir, extsep);
  infsize = sfsize(hs);
  if (infsize > 5) {
    buff = Malloc(infsize);
    if (buff != NULL) {
      k = sfopen(hs, FO_READ);
      if (k >= minhandle) {
        infsize = sfread(k, infsize, buff);
        sfclose(&k);
        found = false;
        lz = 0;
        while ((lz < infsize) && (!found)) {
          get_line(buff, &lz, infsize, hs);
          if (strpos2(subst, hs, 1) == 1) {
            found = true;
            Result = true;
            if (lz < infsize)
              get_line(buff, &lz, infsize, name);
            gkdeutsch(name);
            if (lz < infsize)
              get_line(buff, &lz, infsize, hs);
            *waz = ((short)(hs[0])-(short)('0'))*10 + ((short)(hs[1])-(short)('0'));
            *itu = ((short)(hs[2])-(short)('0'))*10 + ((short)(hs[3])-(short)('0'));
            if (*waz < 1 || *waz > 255)
              *waz = 0;
            if (*itu < 1 || *itu > 255)
              *itu = 0;
            strsub(continent, hs, 5, 2);
            if (lz < infsize)
              get_line(buff, &lz, infsize, hs);
            *lon = atof(hs);
            if (lz < infsize)
              get_line(buff, &lz, infsize, hs);
            *lat = atof(hs);
          } else {
            for (k = 1; k <= 4; k++) {
              if (lz < infsize)
                get_line(buff, &lz, infsize, hs);
            }
          }
        }
      }
      mymfreep(&buff);
    }
  }
  return Result;
}

/* small digiinfo-support */

static void mystrcpy(char *s1, char *s2)
{
  if (s2 == NULL || strlen(s2) > 80) *s1 = '\0';
  else {
    strcpy(s1, s2);
    del_blanks(s1);
  }
}

boolean get_digimap_data(boolean bbs, char *call_, char *sysop, char *mbsysop, char *qthloc,
			 char *qthname, char *mbsystem, char *digisystem, char *remarks,
			 char *updatetime)
{
  short k, ret, state;
  long size, pos, interval;
  boolean is_mb;
  char hs[256], call[256], filename[256], line[256];
  char tcall[80], tstate[80], ttyp[80], tsoft[80], thard[80], tfreq[80],
       tbaud[80], tsysop[80], tloc[80], tqth[80], trem[80], ti[80], tupdate[80];
  char *s;
  
  *sysop = '\0';
  *qthloc = '\0';
  *qthname = '\0';
  *mbsysop = '\0';
  *mbsystem = '\0';
  *digisystem = '\0';
  *remarks = '\0';
  *updatetime = '\0';
  
  sprintf(filename, "%sdigimap%cstn", boxsysdir, extsep);
  size = sfsize(filename);
  if (size < 200)
    return false;
  
  interval = size / 2;
  pos = interval;
  
  k = sfopen(filename, FO_READ);
  if (k < minhandle)
    return false;
  
  del_callextender(call_, call);
  upper(call);
    
  while (interval > 20 && pos >= 0 && pos < size) {
  
    if (sfseek(pos, k, SFSEEKSET) != pos) {
      sfclose(&k);
      return false;
    }
    
    interval = interval / 2;

    file_to_string(k, hs);
    file_to_string(k, hs);
    
    s = strtok(hs, "-, ");
    if (s == NULL)
    	ret = 1;
    else
    	ret = strcmp(call, s);
    if (ret == 0) {

      pos = pos - 1500;
      if (pos < 0) pos = 0;
      if (sfseek(pos, k, SFSEEKSET) != pos) {
        sfclose(&k);
        return false;
      }
      file_to_string(k, hs);
      state = 0;
      while (state < 15) {
        file_to_string(k, line);
        strcpy(hs, line);
        s = strtok(hs, "-, ");
        if (s != NULL && !strcmp(call, s)) {
          state++;
                       
          mystrcpy(tcall, strtok(line, ","));
          mystrcpy(ti, strtok(NULL, ","));
          mystrcpy(tstate, strtok(NULL, ","));
          mystrcpy(tupdate, strtok(NULL, ","));
          mystrcpy(ttyp, strtok(NULL, ","));
          mystrcpy(tsoft, strtok(NULL, ","));
          mystrcpy(thard, strtok(NULL, ","));
          mystrcpy(tfreq, strtok(NULL, ","));
          mystrcpy(tbaud, strtok(NULL, ","));
          mystrcpy(tsysop, strtok(NULL, ","));
          mystrcpy(tloc, strtok(NULL, ","));
          mystrcpy(tqth, strtok(NULL, ","));
          mystrcpy(trem, strtok(NULL, ","));
                    
          is_mb = false;
          
          if (*updatetime == '\0' || strcmp(tupdate, updatetime) > 0)
            strcpy(updatetime, tupdate);

          if (!strcmp("DI", ttyp)) {
            if (*digisystem == '\0')
             strcpy(digisystem, tsoft);
            else if (strstr(digisystem, tsoft) == NULL) {
              strcat(digisystem, ",");
              strcat(digisystem, tsoft);
            }
          } else if (!strcmp("MB", ttyp)) {
            is_mb = true;
            if (*mbsystem == '\0')
             strcpy(mbsystem, tsoft);
            else if (strstr(mbsystem, tsoft) == NULL) {
              strcat(mbsystem, ",");
              strcat(mbsystem, tsoft);
            }
          }          

          if (*tsysop != '\0') {
            if (is_mb)
              strcpy(mbsysop, tsysop);
            if (*sysop == '\0')
              strcpy(sysop, tsysop);
            else if (strstr(sysop, tsysop) == NULL) {
              strcat(sysop, ", ");
              strcat(sysop, tsysop);
            }
          }
          
          if (*tloc != '\0' && (*qthloc == '\0' || (bbs && is_mb)))
            strcpy(qthloc, tloc);

          if (*tqth != '\0' && (*qthname == '\0' || (bbs && is_mb)))
            strcpy(qthname, tqth);
            
          if (*trem != '\0') {
            if (*remarks == '\0')
              strcpy(remarks, trem);
            else if (strlen(remarks) + strlen(trem) < 78) {
              strcat(remarks, " ");
              strcat(remarks, trem);
            }
          }
          
        } else if (state > 0)
          state = 100;
      }
    
      sfclose(&k);
      return true;

    } else if (ret < 0)
      pos -= interval;
    else 
      pos += interval;
    
  }
  
  sfclose(&k);
  return false;
}

/* Modified for use in DPBOX by Joachim Schurig, DL8HBS   */
/* code based on FUZZYSRCH.C of Reinhard Rapp, c't 4/1997 */
/* original header follows:                               */

/*    Unscharfe Suche im Information Retrieval               */
/*    (C) 1997 Reinhard Rapp                                 */
/*    ANSI C, getestet mit GNU C unter UNIX und MS-DOS,      */
/*    Borland C 5.0 unter Windows 95,                        */
/*    Metrowerks C (CW10) unter MacOS                        */

/* #include <stdio.h>
   #include <stdlib.h>
   #include <ctype.h>
   #include <string.h> */

#define  MaxParLen 1000   /* maximale Laenge eines Absatzes */

/* Grossbuchstaben in Kleinbuchstaben, Satzzeichen und div.  */
/* Sonderzeichen in Leerzeichen umwandeln, Laenge ermitteln  */
static long PrepareTheString(char* ConvStr, char* OriginStr)
{
  char*  TmpPtr;

  for (TmpPtr = ConvStr; *OriginStr; TmpPtr++, OriginStr++)
    {
      *TmpPtr = tolower(*OriginStr);
      if (*OriginStr < '0')  /* Satzzeichen neutralisieren   */
        *TmpPtr = ' ';
      else
        switch((unsigned char)*TmpPtr)
          {
            case 196: *TmpPtr = 228; break; /* ANSI-Umlaute  */
            case 214: *TmpPtr = 246; break;
            case 220: *TmpPtr = 252; break;
            case 142: *TmpPtr = 132; break; /* ASCII-Umlaute */
            case 153: *TmpPtr = 148; break;
            case 154: *TmpPtr = 129; break;
            case ':': *TmpPtr = ' '; break;
            case ';': *TmpPtr = ' '; break;
            case '<': *TmpPtr = ' '; break;
            case '>': *TmpPtr = ' '; break;
            case '=': *TmpPtr = ' '; break;
            case '?': *TmpPtr = ' '; break;
            case '[': *TmpPtr = ' '; break;
            case ']': *TmpPtr = ' '; break;
          }
    }
  *TmpPtr = '\0';
  return (TmpPtr - ConvStr);
}

/* sucht n-Gramme im Text und zaehlt die Treffer */
static int NGramMatch(char *TextPara, char *SearchStr,
               short SearchStrLen, short NGramLen, short *MaxMatch)
{
  char    NGram[8];
  short   NGramCount;
  short   i, Count;

  NGram[NGramLen] = '\0';
  NGramCount = SearchStrLen - NGramLen + 1;

/* Suchstring in n-Gramme zerlegen und diese im Text suchen */
  for(i = 0, Count = 0, *MaxMatch = 0; i < NGramCount; i++)
    {
      memcpy(NGram, &SearchStr[i], NGramLen);
      
      /* bei Wortzwischenraum weiterruecken */
      if (NGram[NGramLen - 2] == ' ' && NGram[0] != ' ')
          i += NGramLen - 3;
      else
        {
          *MaxMatch  += NGramLen;
          if(strstr(TextPara, NGram)) Count++;
        }
    }
  return Count * NGramLen;  /* gewichten nach n-Gramm-Laenge */
}

/* fuehrt die unscharfe Suche durch */
short FuzzyMatching(char *CheckStr, char* SearchStr,
		    short SearchStrLen, short NGram1Len, short NGram2Len)
{
  char    TextPara[MaxParLen] = " ";     /* vorn Leerzeichen */
  short   TextLen;
  short   MatchCount1, MatchCount2;
  short   MaxMatch1, MaxMatch2;

  /* Text absatzweise lesen und durchsuchen */
  TextLen = PrepareTheString(&TextPara[1], CheckStr);
  if (TextLen < MaxParLen - 2)
  {
      MatchCount1 = NGramMatch(TextPara, SearchStr,
                      SearchStrLen, NGram1Len, &MaxMatch1);
      MatchCount2 = NGramMatch(TextPara, SearchStr,
                      SearchStrLen, NGram2Len, &MaxMatch2);

      /* Trefferguete berechnen und Bestwert festhalten  */
      return calc_prozent((MatchCount1 + MatchCount2),
                          (MaxMatch1 + MaxMatch2));
  }

  return 0;

}

void PrepareFuzzySearch(char *SearchStr, char *NormalisedStr,
			short *SearchStrLen, short *NGram1Len, short *NGram2Len)
{
  /* n-Gramm-Laenge in Abhaengigkeit vom Suchstring festlegen*/
  *NormalisedStr = '\0';
  strcpy(NormalisedStr, " ");
  strcat(NormalisedStr, SearchStr);
  *SearchStrLen = PrepareTheString(NormalisedStr, NormalisedStr);
  *NGram1Len = 3;
  *NGram2Len = (*SearchStrLen < 7) ? 2 : 5;
}

#undef MaxParLen
/* End of FUZZYSRCH.C for DPBOX */


void _tools_init(void)
{
  static int _was_initialized = 0;
  if (_was_initialized++)
    return;
  cpuspeed = 0;
  last_ixtime = 0;
  last_day = 0;
  PADDINGOK = false;   /* MD2 */
}
